//--------------------------------------------------------------------------------------------------
//Autor: DrakMrak
//CalcBG.pas - vypocet odznacku
//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------
{$IFNDEF BGTYPE}
{$I Badges.Type.pas}
{$ENDIF}
//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------	
//uvolnovaci funkce modulu
procedure CalcBG_Free;
begin
  Log('Start CalcBG_Free()');
end;

function GetStateData(sCountry,sType:String):String;
var ini:TMemIniFile;
    s:string;
begin
  //nacte states TAG a pocet regionu existuje-li Typ:'T' nebo jen regiony TYP:'S'
  Result:='';
  ini:=TMemIniFile.Create(GetModulesDir()+'Badges.CountOfRegions.ini');
  try
	case sType of
		'T': s:=ini.ReadString('geoget-polygons',sCountry,'');
		else s:=ini.ReadString('geocaching.com',sCountry,'');
    end;
    Result:=s;
  finally
    ini.Free();
  end;
end;

function GetStatesGroupData(sBGName:String):String;
var ini:TMemIniFile;
	s: string;
begin
  Result:='';  
  ini:=TMemIniFile.Create(GetModulesDir()+'Badges.BGDefinitions.ini');
  try
	s:=ini.ReadString('badges-statesgroup-def',sBGName,'');
	//Log('Continent: '+s);
	Result:=s;
  finally
	ini.Free();
  end;	
end;

function GetLimitData(sBGName:String):String;
var ini:TMemIniFile;
    s,sn:string;
begin
  Result:='';
  ini:=TMemIniFile.Create(GetModulesDir()+'Badges.BGDefinitions.ini');
  try
	s:=ini.ReadString('badges-limits-def',sBGName,'');
	sn:=Fetch(s,'|');
	Result:=s;
  finally
	ini.Free();
  end;
end;

function GetISOData(sISO2:String):String;
var ini:TMemIniFile;
begin
  Result:='';
  ini:=TMemIniFile.Create(GetModulesDir()+'Badges.BGDefinitions.ini');
  try
	Result:=ini.ReadString('country-iso',sISO2,'');
  finally
	ini.Free();
  end;
end;

function CheckINI():Int64;
var s,sVer,sFile:string;
begin
  Result:=0;
  try
  	sFile:=GetModulesDir()+'Badges.BGDefinitions.ini';
  	s:=FileToString(sFile);
  	while(s<>'') do begin
    	sVer:=Fetch(s,CRLF);
    	if(Pos('version=',sVer)>=1) then break;
  	end;
  	if(sVer<>'') then begin
		Result:=1;
		Log('BGParams - '+sVer);
  	end;
  except
  end;
  //
  try
  	sFile:=GetModulesDir()+'Badges.CountOfRegions.ini'
  	s:=FileToString(sFile);
  	while(s<>'') do begin
    	sVer:=Fetch(s,CRLF);
    	if(Pos('version=',sVer)>=1) then break;
  	end;
  	if(sVer<>'') then begin
		Result:=Result+10;
		Log('CountOfRegions - '+sVer);
  	end;
  except
  end;
end;

function CalcBG_GetData(aParam:TStringList):String;
var
	i,j : integer;
	Name, Width, Option, cc, ccx: String;
	Center,Isok: boolean;
begin
	Result := ''; Width := ''; Option := ''; Isok:=false; Center:=false; cc:='';
	if(aParam<>nil) then begin
		For i := 0 to aParam.Count-1 do begin
			if Pos('NAME',Uppercase(aParam[i])) > 0  then 
				Name := ReplaceString(aParam[i],Copy(aParam[i],1,4)+':','');
			if Pos('WIDTH',Uppercase(aParam[i])) > 0  then 
				Width := ReplaceString(aParam[i],Copy(aParam[i],1,5)+':','');
			if Pos('HCENTER',Uppercase(aParam[i])) > 0  then 
				Center := (Uppercase(ReplaceString(aParam[i],Copy(aParam[i],1,7)+':','')) = 'YES');
			if Pos('OPTION',Uppercase(aParam[i])) > 0  then 
				Option := ReplaceString(aParam[i],Copy(aParam[i],1,6)+':','');
		end;
		Log('Badge: '+Name);
		if Width = '' then Width := '100';			//100%
		if Center then begin
			cc := ' style="vertical-align: middle;"'
			ccx := ' vertical-align: middle;'
		end;
		For i := 0 to High(CalcBG_Data) do begin
			j := CalcBG_Data[i].Index;
			if Uppercase(CalcBG_Badges[j].Name) = Uppercase(Name) then begin
				Isok:=true;
				break;	
			end;
		end;
		if Isok then begin
			case Uppercase(Option) of
				'URL'	:Result := CalcBG_Data[i].Image;
				'VALUE'	:Result := '<span'+cc+'>'+IntToStr(CalcBG_Data[i].Value) + CalcBG_Badges[j].Units+'</span>';
				'HINT'	:Result := '<span'+cc+'>'+CalcBG_Data[i].Info+'</span>';
				else begin
					if CalcBG_Data[i].OverlayImg <> '' then
						Result := '<img style="background:url(' + CalcBG_Data[i].Image 
						+ '); background-size:' + ReplaceString(Width,'%','') + 'px;'+ccx+'" src="' 
						+ CalcBG_Data[i].OverlayImg + '" width="' + ReplaceString(Width,'%','') 
						+ '" title="' + CalcBG_Data[i].Info + '" />'
					else
						Result := '<img src="' + CalcBG_Data[i].Image
						+ '"'+cc+' width="' + ReplaceString(Width,'%','') + '" title="'
						+ CalcBG_Data[i].Info + '" />';
				end;
			end;
		end;
	end;
end;

function CalcBG_GetFlagData(aParam:TStringList):String;
var
	i,j : integer;
	Name, Width, Option, cc, ccx: String;
	Center, Isok: boolean;
begin
	Result := ''; Width := ''; Option := ''; Isok:=false; Center:=false; cc:='';
	if(aParam<>nil) then begin
		For i := 0 to aParam.Count-1 do begin
			if Pos('NAME',Uppercase(aParam[i])) > 0  then 
				Name := ReplaceString(aParam[i],Copy(aParam[i],1,4)+':','');
			if Pos('WIDTH',Uppercase(aParam[i])) > 0  then 
				Width := ReplaceString(aParam[i],Copy(aParam[i],1,5)+':','');
			if Pos('HCENTER',Uppercase(aParam[i])) > 0  then 
				Center := (Uppercase(ReplaceString(aParam[i],Copy(aParam[i],1,7)+':','')) = 'YES');
			if Pos('OPTION',Uppercase(aParam[i])) > 0  then 
				Option := ReplaceString(aParam[i],Copy(aParam[i],1,6)+':','');
		end;
		Log('Badge flag: '+Name);
		if Width = '' then Width := '100';				//100%
		if Center then begin
			cc := ' style="vertical-align: middle;"'
			ccx := ' vertical-align: middle;'
		end;
		For i := 0 to High(CalcBG_StateData) do begin
			j := CalcBG_StateData[i].Index;
			if Uppercase(CalcBG_StateData[i].RealName) = Uppercase(Name) then begin
				Isok:=true;
				break;	
			end;	
		end;
		if Isok then begin
			case Uppercase(Option) of
				'URL'	:Result := CalcBG_StateData[i].Image;
				'VALUE'	:Result := '<span'+cc+'>'+IntToStr(CalcBG_StateData[i].Value) + CalcBG_Badges[j].Units+'</span>';
				'HINT'	:Result := '<span'+cc+'>'+CalcBG_StateData[i].Info+'</span>';
				else begin
					if CalcBG_StateData[i].OverlayImg <> '' then
						Result := '<img style="background:url(' + CalcBG_StateData[i].Image 
						+ '); background-size:' + ReplaceString(Width,'%','') + 'px;'+ccx+'" src="' 
						+ CalcBG_StateData[i].OverlayImg + '" width="' + ReplaceString(Width,'%','') 
						+ '" title="' + CalcBG_StateData[i].Info + '" />'
					else
						Result := '<img src="' + CalcBG_StateData[i].Image
						+ '"'+cc+' width="' + ReplaceString(Width,'%','') + '" title="'
						+ CalcBG_StateData[i].Info + '" />';						
				end;
			end;
		end;
	end;
end;

//ISO2 --> ISO3 	
function BG_iso2toiso3(iso2:String):String;
begin
  if iso2 = 'UK' then iso2 := 'GB';		//Uprava pro anglii
  Result := GetISOData(iso2);
end;
//
//Rozkucha limity ze stringu
function BG_LimitParser(const text, oddelovac : String):Tlimit;
var
	i : integer;
	stmp : String;
	tmp : Tlimit;
begin
	for i := 0 to 7 do begin
		stmp := Fetch(text, oddelovac);
		if stmp = '' then stmp := '0';
		tmp[i] := StrToInt(stmp);
	end;
	Result := tmp;
end;
///----------------------------------------------------------------------------
///Inicializuje se matice odznaku (max_bg = pocet)
///----------------------------------------------------------------------------
procedure BG_IniArray(const ShortName, Name, Limits, Units, Optional, Sign, Flags, GlobalVar, BPCoef: String);
var 
	tmp: TBadgeDef;
begin
	if (Pos('W',Flags) > 0) AND NOT (CalcBG_INI.bWaymarking) then exit;	//waymarking NE
	//
	SetLength(CalcBG_Badges, Length(CalcBG_Badges) + 1);
	//----------------------------------------------------------------------------------------------
	tmp.ShortName := ShortName;													//Short name
	tmp.Name := Name;															//Name
	tmp.Limits := BG_LimitParser(Limits, ',');									//Normal
	if (Pos('E',Flags) > 0) then 
		tmp.LimitsEU := BG_LimitParser(Optional, ',')							//Special nebo EU
	else 
		tmp.LimitsEU := BG_LimitParser(Limits, ',');							//Normal
	if (Pos('#',Units) > 0) then
		tmp.Units := Chr(StrToInt(ReplaceString(Units,'#','')))					//Units - special char
	else	
		tmp.Units := Units;														//Units
	tmp.Sign := Sign;															//Sign
	tmp.Flags := Flags;															//Flagy
	if Pos('E',Flags) > 0 then tmp.Optional := ''								//EU nic
	else tmp.Optional := Optional;												//Optional
	tmp.GlobalVariables := GlobalVar;											//GlobalVariables
	//Black Pearl - Badge --------------------------------------------------------------------------
	if BPCoef = '*' then BPCoef := '-1';
	if StrToInt(BPCoef) > 0 then begin
		tmp.BP := Round(tmp.Limits[7] * (StrToInt(BPCoef)/100.00));				//BP
		tmp.BPEU := Round(tmp.LimitsEU[7] * (StrToInt(BPCoef)/100.00));			//BP pro EU
	end
	else begin
		tmp.BP := StrToInt(BPCoef);												//nasobek (-1 = nic, -2 = x2)
		tmp.BPEU := StrToInt(BPCoef);											//nasobek EU (-1 = nic, -2 = x2)
	end;
	//----------------------------------------------------------------------------------------------
	CalcBG_Badges[High(CalcBG_Badges)] := tmp;
end;
//
procedure BG_InitBadges();
begin
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	//[0] - ID - Identifikator odznacku, 
	//[1] - Name - realne jmeno odznacku, 
	//[2] - Limit - limity odznacku (Original), 
	//[3] - Units - jednotky jsou-li potreba napr. (km, m, %), 
	//[4] - Limit - limity odznacku (EU), 
	//[5] - '+/-' - znam?nko (neco je i do minusu), 
	//[6] - Flag - Flagy pro rizeni vystupu HTML (popsany nize a mohou se kombinovat),
	//[7] - globalni promenna - prevzato ze Statoru
	//[8] - BlackPearl - koeficient %(-2 = 2x a nebo jinak - speci?l).              (-2)
	//                   jinak pres procenta eg.:125 = Diamond[level] * (125/100)   (procenta)
	//                   a pokud je tam '*' tak NIC nem? to BP                      (-1)
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	//Flag: 'Z' - ZERO - nektere polozky 0 - preskakuji se (kazdy takov? m? svoji sekci IF kde se ??k? co pat?? k ?emu)
	//Flag: 'S'	- STATES - statni vlajky, a podobna uskupeni
	//Flag:	'L'	- LIMIT - prepocitava se Limit 
	//Flag: '%' - PROCENTA - Limity se generuj? z procent za b?hu podle celkov? sumy
	//Flag: 'F' - ADRNOF - Adres?? odznaku nen? 'flag'
	//Flag: 'E' - EUROPE - EU/US jiny zpusob pocitani - bere pro pocitani 
	//					   hodnoty z Additional je-li EU (u? asi nepou??v?m!)
	//Flag: 'C' - COMMENT - je komentar
	//Flag: 'W' - WAYMARKING - odznaky waymarkingu
	//Flag:	'B'	- BLACK PEARL - ?ern? perla (p?id?v? se za b?hu)
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	//Error Badge
	BG_IniArray('Err','Error!','1,1,1,1,1,1,1,1,','','','+','','','*');
	//
	BG_IniArray('GGeoc','The Geocacher',GetLimitData('GGeoc'),'','','+','','FoundCachesCount','250');
	BG_IniArray('Trad','The Traditional Cacher',GetLimitData('Trad'),'','','+','','Calc_CacheTraditionalCount','250');
	BG_IniArray('Mult','The Multi Cacher',GetLimitData('Mult'),'','','+','','Calc_CacheMultiCount','250');
	BG_IniArray('Myst','The Mysterious Cacher',GetLimitData('Myst'),'','','+','','Calc_CacheMysteryCount','250');
	BG_IniArray('Virt','The Virtual Cacher',GetLimitData('Virt'),'','','+','','Calc_CacheVirtualCount','250');
	BG_IniArray('Eart','The Earth Cacher',GetLimitData('Eart'),'','','+','','Calc_CacheEarthCount','250');
	BG_IniArray('Lett','The Letterboxer',GetLimitData('Lett'),'','','+','','Calc_CacheLetterboxCount','250');
	BG_IniArray('Wher','The Wherigo Cacher',GetLimitData('Wher'),'','','+','','Calc_CacheWherigoCount','250');
	BG_IniArray('Mega','The Mega Social Cacher',GetLimitData('Mega'),'','','+','','Calc_CacheMegaEventCount','250');
	BG_IniArray('Giga','The Giga Social Cacher',GetLimitData('Giga'),'','','+','Z','Calc_CacheGigaEventCount','250');
	BG_IniArray('MAZE','The Gps Maze Cacher',GetLimitData('MAZE'),'','','+','','Calc_CacheGPSAdventuresExhibitCount','250');
	BG_IniArray('Even','The Social Cacher',GetLimitData('Even'),'','','+','','Calc_CacheEventCount','250');
	//
	BG_IniArray('CITO','The Environmental Cacher',GetLimitData('CITO'),'','','+','','Calc_CacheCITOCount','250');
	BG_IniArray('Teny','The Community Celebration Cacher',GetLimitData('Teny'),'','','+','','Calc_CacheLostAndFoundCount|Calc_CacheCommunityCelebrationEvent','*');
	BG_IniArray('Benc','The Benchmarker',GetLimitData('Benc'),'','','+','','','125');
	BG_IniArray('Webc','The Photogenic Cacher',GetLimitData('Webc'),'','','+','','Calc_CacheWebcamCount','*');
	BG_IniArray('Apec','The APE Cacher',GetLimitData('Apec'),'','','+','Z','Calc_CacheAPECount','*');
	BG_IniArray('Lab','The LAB Cacher',GetLimitData('Lab'),'','','+','','Calc_CacheLabCount','250');
	BG_IniArray('GLab','The LAB Completer',GetLimitData('GLab'),'','','+','','','250'); //1.3.1
	BG_IniArray('Micr','The Micro Cacher',GetLimitData('Micr'),'','','+','','Calc_CacheMicroCount','250');
	BG_IniArray('Smal','The Small Cacher',GetLimitData('Smal'),'','','+','','Calc_CacheSmallCount','250');
	BG_IniArray('Regu','The Regular Cacher',GetLimitData('Regu'),'','','+','','Calc_CacheRegularCount','250');
	BG_IniArray('Larg','The Large Cacher',GetLimitData('Larg'),'','','+','','Calc_CacheLargeCount','250');
	BG_IniArray('Odds','The Odd-sized Cacher',GetLimitData('Odds'),'','','+','','Calc_CacheOtherCount|Calc_CacheNotChosenCount','250'); //1.3.0
	//
	BG_IniArray('Five','The Adventurous Cacher',GetLimitData('Five'),'','','+','','Calc_CacheD5T5Count','250');	
	BG_IniArray('Lazy','The Lazy Cacher',GetLimitData('Lazy'),'','','+','','Calc_CacheD1T1Count','250');
	BG_IniArray('Difi','The Brainiac',GetLimitData('Difi'),'','','+','','Calc_CacheD5Count','250');
	BG_IniArray('Terr','The Rugged Cacher',GetLimitData('Terr'),'','','+','','Calc_CacheT5Count','250');
	BG_IniArray('Matr','The Matrix Cacher',GetLimitData('Matr'),'','','+','','Calc_MatrixDifficultyTerrain','-2');
	BG_IniArray('Uniq','The Diverse Cacher',GetLimitData('Uniq'),'','','+','','Calc_CacheMaxUniqueDailyType','*');
	BG_IniArray('FTF','The FTF Addict',GetLimitData('FTF'),'','','+','','Calc_FTFCount','250');
	BG_IniArray('WPed','The Cacher on Winners Pedestal',GetLimitData('WPed'),'','','+','','Calc_FTFCount|Calc_STFCount|Calc_TTFCount','250');
	BG_IniArray('Hidd','The Cache Owner',GetLimitData('Hidd'),'','','+','','Calc_OwnedCount','250');
	BG_IniArray('Host','The Event Host',GetLimitData('Host'),'','','+','','Calc_EventHostCount','250');
	//
	BG_IniArray('Elev','The High Altitude Cacher',GetLimitData('Elev'),' m','','+','','Calc_LocHighestAlt','120');
	BG_IniArray('Lowe','The Low Altitude Cacher',GetLimitData('Lowe'),' m','','-','','Calc_LocLowestAlt','250');
	BG_IniArray('States','State Badges',GetLimitData('States'),'','','+','CSL','','*');
	BG_IniArray('Evro','The Europe Cacher',GetLimitData('Evro'),'','','+','CS','','*');
	BG_IniArray('EUR','The EU Cacher',GetLimitData('EUR'),'','','+','CS','','*');
	BG_IniArray('ATBez','The AT Bezirk Cacher',GetLimitData('ATBez'),'','','+','CSF','','*');
	BG_IniArray('CZDist','The CZ District Cacher',GetLimitData('CZDist'),'','','+','CSF','','*');
	BG_IniArray('SKDist','The SK District Cacher',GetLimitData('SKDist'),'','','+','CSF','','*');
	BG_IniArray('Coun','The Travelling Cacher',GetLimitData('Coun'),'','','+','','','200');
	BG_IniArray('Twen','The Busy Cacher',GetLimitData('Twen'),'','','+','','','125');
	//
	BG_IniArray('Cons','The Daily Cacher',GetLimitData('Cons'),'','','+','C','Calc_FoundStreakDaily','250');
	BG_IniArray('Cale','The Calendar Cacher',GetLimitData('Cale'),'','','+','','','-2');
	BG_IniArray('Unde','The Scuba-Cacher',GetLimitData('Unde'),'','','+','','','250');
	BG_IniArray('Dist','The Long-Distance Cacher',GetLimitData('Dist'),' km','','+','C','','125');
	BG_IniArray('Tlov','The Trackable Lover',GetLimitData('Tlov'),'','','+','','CalcGS_TrackablesFoundCount','250');
	BG_IniArray('CWG','The CWG Collector',GetLimitData('CWG'),'','','+','','','250');
	BG_IniArray('Author','The Author',GetLimitData('Author'),'','','+','','Calc_LogsSum','*');	//1.3.0
	BG_IniArray('Vete','The Caching Veteran',GetLimitData('Vete'),'','','+','','Calc_RealYearsTotal','125');
	BG_IniArray('NightOwl','The Night-Owl',GetLimitData('NightOwl'),'','','+','','','125');
	//
	BG_IniArray('Favo','The Favorited Owner',GetLimitData('Favo'),'','','+','','Calc_OwnedFavoritePoints','250');
	BG_IniArray('Phot','The Shutterbug',GetLimitData('Phot'),'','','+','','CalcGS_UserGalleryImagesCount','*');
	BG_IniArray('DayNight','The Night Cacher',GetLimitData('DayNight'),'','','+','','','250');
	BG_IniArray('Bear','The All Around Cacher',GetLimitData('Bear'),'#176','','+','','','-2');
	BG_IniArray('Waym','The Waymarker',GetLimitData('Waym'),'','','+','W','','250');
	BG_IniArray('WMaut','The Waymark creator',GetLimitData('WMaut'),'','','+','W','','200');
	BG_IniArray('WCat','The Waymark categories discoverer',GetLimitData('WCat'),'','','+','W','','125');
	BG_IniArray('High','The Highlander Cacher',GetLimitData('High'),'','','+','','','-2');	//1000 m n.m.(klasik)/1500 m n.m. (BP)
	//
	BG_IniArray('Asia','The Asia Cacher',GetLimitData('Asia'),'','','+','CS','','*');
	BG_IniArray('Afri','The Africa Cacher',GetLimitData('Afri'),'','','+','CS','','*');
	BG_IniArray('Amer','The America Cacher',GetLimitData('Amer'),'','','+','CS','','*');
	BG_IniArray('Aust','The Australia and Oceania Cacher',GetLimitData('Aust'),'','','+','CS','','*');
	BG_IniArray('Chal','The Achiever',GetLimitData('Chal'),'','','+','','','250');				//1.3.0 Challenge
	BG_IniArray('Jasmer','The Jasmer Cacher',GetLimitData('Jasmer'),'','','+','%','','250');		//1.3.0 JASMER (p?epo?et limit? z % na po?ty)
	BG_IniArray('Wheel','The Wheelchair Accesibled Cacher',GetLimitData('Wheel'),'','','+','','Calc_CacheT1Count','250');		//1.3.0 T1 ke?e
	BG_IniArray('QTH','The QTH Locator Cacher',GetLimitData('QTH'),'','','+','','','250');
	//-------------------------------------------------------------------------
end;

///----------------------------------------------------------------------------
///Vytahne podle jmena ze seznamu data odznacku
///----------------------------------------------------------------------------
function BG_GetRealBg(Name:String):TBadgeDef;
var
	i		: integer;
	res		: TBadgeDef;
begin
	res.ShortName := 'NULL';
	For i := 0 to High(CalcBG_Badges) do begin
		if CalcBG_Badges[i].Name = Name then begin
			res := CalcBG_Badges[i];
			break;
		end;
	end;
	Result := res;
end;


//Vytvori jmeno odznacku
function BG_xName(const name, units : string; const lo, hi : integer; const kladne : boolean): string;
var
	pm,u,rname : String;
begin
	Result := ''; rname := '';
	case name of
		'B': rname := 'Bronze';
		'S': rname := 'Silver';
		'G': rname := 'Gold';
		'P': rname := 'Platinum';
		'R': rname := 'Ruby';
		'Sa': rname := 'Sapphire';
		'E': rname := 'Emerald';
		'D': rname := 'Diamond';
		'Gray': rname := 'None';
		'BP': rname := 'Black Pearl';
	end;
	u := units;
	if kladne then pm := '' else pm := '-';
	//Log(IntToStr(lo)+'...'+IntToStr(hi));
	if (hi = 0) or (hi = lo) or (hi = (lo + 1)) then begin
		if lo = 0 then Result := rname + ' (' + Trim(IntToStr(lo)) + u + ')'
		else Result := rname + ' (' + pm + Trim(IntToStr(lo)) + u + ')';
	end
	else begin
		if name = 'D' then
			Result := rname + ' (' + pm  + Trim(IntToStr(lo)) + u + '+)'
		else if name = 'BP' then
			Result := rname + ' (' + pm  + Trim(IntToStr(lo)) + u + '+)'
		else	
			Result := rname + ' (' + pm  + Trim(IntToStr(lo)) + u + ' - ' + pm  
					+  Trim(IntToStr(hi-1)) + u + ')';
	end;
end;

///----------------------------------------------------------------------------
///Vytvori odznacek a info k nemu
///----------------------------------------------------------------------------
procedure BG_ResultBadge(BG: TBadgeDef; const Value: Int64; 
	                var BgIdx, Img, Info: String; 
					var percent: integer;
					var ImgN: String);
var
	lmt				:TLimit;
	hi, lo, nas, i 	:int64;
	idx, tit		:String;
	imgname     	:String;
	unithodnota		:String;
	pm				:String;
	BPreal			:integer;
	rokAkt,mesAkt,month	:integer;
	
//Vlastni procedura tvorby odznacku
begin
	try
		Log('BG = ' + BG.ShortName);
		Log('Value = ' + IntToStr(Value));
		//
		if Pos('L',BG.Flags) = 0 then begin								//neprepocitavane limity
			if CalcBG_INI.bIsOriginal then begin
				RealLimit := BG.Limits;									//Limit klasika - uvodni
				BPreal := BG.BP;
			end
			else begin													//jeden limit EU
				RealLimit := BG.LimitsEU;								//Limit EU
				BPreal := BG.BPEU;
			end;
		end;
		if Pos('%',BG.Flags) = 1 then begin
			if BG.ShortName = 'Jasmer' then begin 
				rokAkt:=StrToInt(FormatDateTime('yyyy',Now()))-2001;
  				mesAkt:=StrToInt(FormatDateTime('m',Now()))-1;
				month:= 8+rokAkt*12+mesAkt;	//pocet mesicu do 100%
				for i:=0 to 7 do begin
					RealLimit[i] := Round((month/100.00)*RealLimit[i]);
				end;
			end;
		end;	
		lmt := RealLimit;												//pocitam podle tohoto
		//
		lo := 0; hi := 0; nas := 0; //pg := 0;
		idx := ''; tit := '';
		//Nasobek Diamantu
		nas := Value div lmt[7];
		//html := ''; ihtml := '';
		//
		if BG.Sign = '+' then pm := '' else pm := BG.Sign;
		//----------------------------------------------------Specialni rady
		if Pos('Z',BG.Flags) > 0 then begin
			if BG.ShortName = 'Apec' then begin		//APE kese
				case Value of
					0: begin idx := 'Gray'; tit := BG_xName(idx, BG.Units, 0, 0, pm = ''); lo := 0; hi := 0; end; 
					//1: begin idx := 'B'; tit := BG_xName(idx, BG.Units, 1, 1, pm = ''); lo := 1; hi := 1; end; 
					//2: begin idx := 'S'; tit := BG_xName(idx, BG.Units, 2, 2, pm = ''); lo := 2; hi := 2; end;
					1: begin idx := 'G'; tit := BG_xName(idx, BG.Units, 3, 3, pm = ''); lo := 3; hi := 3; end;
					//2: begin idx := 'P'; tit := BG_xName(idx, BG.Units, 4, 4, pm = ''); lo := 4; hi := 4; end;
					//5: begin idx := 'R'; tit := BG_xName(idx, BG.Units, 5, 5, pm = ''); lo := 5; hi := 5; end;
					//6: begin idx := 'Sa'; tit := BG_xName(idx, BG.Units, 6, 6, pm = ''); lo := 6; hi := 6; end;
					2: begin idx := 'E'; tit := BG_xName(idx, BG.Units, 7, 7, pm = ''); lo := 7; hi := 7; end;
					3: begin idx := 'D'; tit := BG_xName(idx, BG.Units, 8, 8, pm = ''); lo := 8; hi := 8; end;
					else begin idx := 'D'; tit := BG_xName(idx, BG.Units, 8, 8, pm = ''); lo := 8; hi := 8; end;
				end;
			end;
			if BG.ShortName = 'Giga' then begin		//Giga eventy
				case Value of
					0: begin idx := 'Gray'; tit := BG_xName(idx, BG.Units, 0, 0, pm = ''); lo := 0; hi := 0; end; 
					//1: begin idx := 'B'; tit := BG_xName(idx, BG.Units, 1, 1, pm = ''); lo := 1; hi := 1; end; 
					1: begin idx := 'S'; tit := BG_xName(idx, BG.Units, 2, 2, pm = ''); lo := 2; hi := 2; end;
					2: begin idx := 'G'; tit := BG_xName(idx, BG.Units, 3, 3, pm = ''); lo := 3; hi := 3; end;
					//3: begin idx := 'P'; tit := BG_xName(idx, BG.Units, 4, 4, pm = ''); lo := 4; hi := 4; end;
					3: begin idx := 'R'; tit := BG_xName(idx, BG.Units, 5, 5, pm = ''); lo := 5; hi := 5; end;
					4: begin idx := 'Sa'; tit := BG_xName(idx, BG.Units, 6, 6, pm = ''); lo := 6; hi := 6; end;
					5: begin idx := 'E'; tit := BG_xName(idx, BG.Units, 7, 7, pm = ''); lo := 7; hi := 7; end;
					6: begin idx := 'D'; tit := BG_xName(idx, BG.Units, 8, 8, pm = ''); lo := 8; hi := 8; end;
					else begin idx := 'D'; tit := BG_xName(idx, BG.Units, 8, 8, pm = ''); lo := 8; hi := 8; end;
				end;
			end;
			if BG.ShortName = 'MAZE' then begin		//Gps MAZE akce
				case Value of
					0: begin idx := 'Gray'; tit := BG_xName(idx, BG.Units, 0, 0, pm = ''); lo := 0; hi := 0; end; 
					//1: begin idx := 'B'; tit := BG_xName(idx, BG.Units, 1, 1, pm = ''); lo := 1; hi := 1; end; 
					//2: begin idx := 'S'; tit := BG_xName(idx, BG.Units, 2, 2, pm = ''); lo := 2; hi := 2; end;
					1: begin idx := 'G'; tit := BG_xName(idx, BG.Units, 3, 3, pm = ''); lo := 3; hi := 3; end;
					2: begin idx := 'P'; tit := BG_xName(idx, BG.Units, 4, 4, pm = ''); lo := 4; hi := 4; end;
					3: begin idx := 'R'; tit := BG_xName(idx, BG.Units, 5, 5, pm = ''); lo := 5; hi := 5; end;
					//4: begin idx := 'Sa'; tit := BG_xName(idx, BG.Units, 6, 6, pm = ''); lo := 6; hi := 6; end;
					4: begin idx := 'E'; tit := BG_xName(idx, BG.Units, 7, 7, pm = ''); lo := 7; hi := 7; end;
					5: begin idx := 'D'; tit := BG_xName(idx, BG.Units, 8, 8, pm = ''); lo := 8; hi := 8; end;
					else begin idx := 'D'; tit := BG_xName(idx, BG.Units, 8, 8, pm = ''); lo := 8; hi := 8; end;
				end;
			end;
			Log('IDX: ' + idx);
		end
		//---------------------------------------------------------------------------Normalni rady jdouci za sebou
		else begin
			if (Pos('B',BG.Flags) = 0) or (not CalcBG_INI.bBlackPearl) then begin
				if (Value >= lmt[0]) and (Value < lmt[1]) and (Pos('S',BG.Flags) = 0) then begin //klasika pro ostatn? 
					idx := 'B'; tit := BG_xName(idx, BG.Units, lmt[0], lmt[1], pm = ''); 
					lo := lmt[0]; hi := lmt[1]-1;
				end
				else if (Value > 0) and (Value < lmt[1]) and (Pos('S',BG.Flags) > 0) then begin //U vlajek sta?? jeden n?lez
					idx := 'B'; tit := BG_xName(idx, BG.Units, 1, lmt[1], pm = ''); 
					lo := lmt[0]; hi := lmt[1]-1;
				end
				else if (Value >= lmt[1]) and (Value < lmt[2]) then begin 
					idx := 'S'; tit := BG_xName(idx, BG.Units, lmt[1], lmt[2], pm = ''); 
					lo := lmt[1]; hi := lmt[2]-1;
				end
				else if (Value >= lmt[2]) and (Value < lmt[3]) then begin 
					idx := 'G'; tit := BG_xName(idx, BG.Units, lmt[2], lmt[3], pm = ''); 
					lo := lmt[2]; hi := lmt[3]-1;
				end
				else if (Value >= lmt[3]) and (Value < lmt[4]) then begin 
					idx := 'P'; tit := BG_xName(idx, BG.Units, lmt[3], lmt[4], pm = ''); 
					lo := lmt[3]; hi := lmt[4]-1;
				end
				else if (Value >= lmt[4]) and (Value < lmt[5]) then begin 
					idx := 'R'; tit := BG_xName(idx, BG.Units, lmt[4], lmt[5], pm = ''); 
					lo := lmt[4]; hi := lmt[5]-1;
				end
				else if (Value >= lmt[5]) and (Value < lmt[6]) then begin 
					idx := 'Sa'; tit := BG_xName(idx, BG.Units, lmt[5], lmt[6], pm = ''); 
					lo := lmt[5]; hi := lmt[6]-1;
				end 
				else if (Value >= lmt[6]) and (Value < lmt[7]) then begin 
					idx := 'E'; tit := BG_xName(idx, BG.Units, lmt[6], lmt[7], pm = ''); 
					lo := lmt[6]; hi := lmt[7]-1;
				end
				else if (Value >= lmt[7]) then begin
					if (Value >= BPreal) and (BPreal > 0) and (CalcBG_INI.bBlackPearl) then begin
						idx := 'BP'; tit := BG_xName(idx, BG.Units, BPreal, -1, pm = ''); 
						lo := BPreal; hi := Value;
					end
					else begin
						idx := 'D'; tit := BG_xName(idx, BG.Units, lmt[7], -1, pm = ''); 
						lo := lmt[7]; hi := Value;
					end;
				end
				else begin 
					idx := 'Gray'; tit := BG_xName(idx, '', 0, lmt[0], pm = ''); 
					lo := 0; hi := lmt[0]-1;
				end;
			end
			else begin
				if Value >= lmt[7] then begin
					idx := 'BP'; tit := BG_xName(idx, BG.Units, lmt[7], -1, pm = ''); 
					lo := lmt[7]; hi := Value;
				end
				else begin
					idx := 'D'; tit := BG_xName(idx, BG.Units, lmt[7], -1, pm = ''); 
					lo := lmt[7]; hi := Value;
				end;
			end;
			Log('IDX: ' + idx);
		end;
		//
		// Comment
		//
		if Pos('C',BG.Flags) > 0 then begin
			if BG.Optional <> '' then tit := tit + ' ' + BG.Optional;
		end;
		//
		// Procenta (graf)
		//
		try
			if Value = 0 then
				percent := 0
			else if hi = lo then
				percent := 100
			else
				percent := Round(((Value - lo) * 100.00)/(hi - lo));			
		except
			percent := 0;
		end;
		//
		// Adresar klasik/vlajky
		//
		if Pos('S',BG.Flags) > 0 then begin
			if Pos('F',BG.Flags) > 0 then
				imgname := CalcBG_INI.sBadgesURL + BG.ShortName + idx
			else
				imgname := CalcBG_INI.sBadgesURL + 'f/' + BG.ShortName + idx;
		end
		else
			imgname := CalcBG_INI.sBadgesURL + BG.ShortName + idx;
		//---------------------------------------------------------------------	
		//DOCASNE !!	
		if (BG.Shortname='GLab') then
		begin
			imgname := 'https://www.geotrebic.cz/b/' + BG.ShortName + idx;
		end;
		//DOCASNE !!
		//---------------------------------------------------------------------	
		unithodnota := pm + Trim(IntToStr(Value)) + BG.Units;
		//---------------------------------------------------------------------
		//---------------------------------------------------------------------
		//Results
		//---------------------------------------------------------------------
		//---------------------------------------------------------------------
		if Pos('S',BG.Flags) > 0 then
			ImgN	:= ''															//Flagy
		else begin
			if (nas > 1) and (nas <= 9) then
				ImgN	:= CalcBG_INI.sBadgesURL + 'N' + IntToStr(nas) + '.png'   	//Obrazek cisla
			else
				ImgN	:= '';														//Nic
		end;
		//---------------------------------------------------------------------
		Img			:= imgname + '.png';		//Odznacek obrazek-------------
		Info 		:= BG.Name + ' - #' + unithodnota + ' / ' + tit;	//Info-
		BgIdx 		:= idx;			//Index - B,S,G,P,R,Sa,E,D,BP,Gray---------
		//---------------------------------------------------------------------
	except
		//---------------------------------------------------------------------
		Inc(nModuleErrors);
		iModuleError := 1;
		sModuleError := _('ERR: Exception during BG Calculation!') + CRLF
					 + ExceptionToString(ExceptionType, ExceptionParam) + CRLF
					 + CRLF + BG.Name + ' (' + IntToStr(Value) + ')';
		if(sModuleError <> '') then Log(sModuleError);
		//---------------------------------------------------------------------
	end;
end;

procedure BG_ParseDelimited(const sl : TStringList; const value : string; const delimiter : string);
var
   dx : integer;
   ns : string;
   txt : string;
   delta : integer;
begin
   delta := Length(delimiter) ;
   txt := value + delimiter;
   sl.BeginUpdate;
   sl.Clear;
   try
     while Length(txt) > 0 do
     begin
       dx := Pos(delimiter, txt) ;
       ns := Copy(txt,0,dx-1) ;
       if trim(ns) <> '' then sl.Add(ns) ;
       txt := Copy(txt,dx+delta,65536) ;
     end;
   finally
     sl.EndUpdate;
   end;
end;

//**************************************************************************************************
//										B A D G E S
//**************************************************************************************************
//----------------------------------------------------------------------------------------------
function BG_tagSQL(ELT,Tag,Value:String):String;
var sql:String;
begin
	sql := 'select count(gc.id) cnt';
	sql := sql + ' from geocache gc';
	sql := sql + ' inner join geotag gt on (gc.id = gt.id and gt.ptrkat IN';
	sql := sql + ' (select key from geotagcategory where value = ''' + Tag + ''' COLLATE NOCASE))';
	if ELT <> 'T' then begin
		sql := sql + ' where gc.dtfound > 0 and gt.ptrvalue IN ';
		Case ELT of
			'E': sql := sql + ' (select key from geotagvalue where value = '''+ Value +''')';
			'L': sql := sql + ' (select key from geotagvalue where value LIKE '''+ Value +''')';
		end;
	end
	else begin
		sql := sql + ' where gc.dtfound > 0';
	end;
	Result := sql;
end;
//----------------------------------------------------------------------------------------------
//
function BG_Badge(BG: TBadgeDef; 
			  var BgIdx, BgHtml, InfHtml, RealName: String; 
			  var Points: extended; 
			  var Value: int64;
			  var percent: integer;
			  var ImgN: String): Boolean;
var
	sql: String;
	aStr, bStr: String;
	i,j,cnt,dis,val: integer;
	ID, sState, sTag, sEvent : String;		//Pomocny
	value_sl, aParams :TStringlist;			//Stringlisty
	table: TSQLiteTable;					//Tabulka
	correct: boolean;
	PreValue: int64;
	elong, elongmax: extended;
	lmt: TLimit;
begin
	//Inicializace
	Result := True; Value := 0; PreValue := 0;
	BgHtml := ''; InfHtml := ''; BgIdx := ''; RealName := ''; Points := -1; ImgN := '';
	sEvent := '(''Giga-Event Cache'',''Mega-Event Cache'',''Event Cache'',''Cache In Trash Out Event'',''Lost and Found Event Cache'')';
	//--------------------------------------------------------------------------	
	//Ziska konkretni odznak ze jmena
	//--------------------------------------------------------------------------
	{BG := BG_GetRealBg(ReplaceString(aParams.Values['BadgeName'], '~', ' '));
	if BG.ShortName = 'NULL' then begin
		Result := False;
		Exit;						//Neexistuje ------> ven
	end;}
	//--------------------------------------------------------------------------
	//Vytvori prislusny odznak podle ID
	//--------------------------------------------------------------------------
	StatorBusy('BG: ' + BG.Name);
	ID := BG.ShortName;
	//--------------------------------------------------------------------------
	case ID of
		//Error badge
		'Err': begin
			Value := 1;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Geocacher
		'GGeoc': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			//Value := 50000;	//Test
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			Points := Value div 100;
		end;
		//The Traditional Cacher
		'Trad': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Multi Cacher
		'Mult': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Mysterious Cacher
		'Myst': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Virtual Cacher
		'Virt': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Earth Cacher
		'Eart': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Letterboxer
		'Lett': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Wherigo Cacher
		'Wher': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Mega Social Cacher
		'Mega': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Giga Social Cacher
		'Giga': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Gps Maze Cacher
		'MAZE': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Social Cacher
		'Even': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Environmental Cacher
		'CITO': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Lost & Found Cacher
		'Teny': begin
			aStr := BG.GlobalVariables;
			Value := StrToInt64(GlobalVarGet(Fetch(aStr,'|'),false));				//Other
			Value := Value + StrToInt64(GlobalVarGet(Fetch(aStr,'|'),false));		//Not chosen
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Benchmarker
		'Benc': begin
			Value := CalcBG_INI.iBenchmark;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Photogenic Cacher
		'Webc': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The APE Cacher
		'Apec': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The LAB Cacher
		'Lab': begin
			PreValue := StrToInt64(GlobalVarGet('Calc_CacheLabCount',false)); //Podle TYPU - 'Calc_CacheLabCount' / Podle API - CalcGS_GeocachesLABCount
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			if Value <> PreValue then Value := PreValue;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The LAB Completer
		'GLab': begin
			sql := 'WITH'; 
  			sql := sql + ' alllab(id, idx, idy, dtf)';
			sql := sql + ' AS (SELECT gc.id, substr(gc.id,1, instr(gc.id, "-")-1) idx, substr(gc.id, instr(gc.id, "-")+1) idy, gc.dtfound dtf';
			sql := sql + ' FROM geocache gc';
			sql := sql + ' WHERE gc.cachetype = "Lab Cache"),';
  			sql := sql + ' labgrp(id,sumfound,sumnotfound)';
			sql := sql + ' AS (SELECT';
  			sql := sql + ' al.idx id,'; 
  			sql := sql + ' SUM(CASE WHEN al.dtf>0 THEN 1 ELSE 0 END) sumfound,';
  			sql := sql + ' SUM(CASE WHEN al.dtf>0 THEN 0 ELSE 1 END) sumnotfound';   
			sql := sql + ' FROM alllab al';
			sql := sql + ' GROUP BY al.idx,'; 
 			sql := sql + ' CASE WHEN length(al.idy) = 1';
      			sql := sql + ' THEN ""';
      			sql := sql + ' ELSE substr(al.idy,1,1) END)';      
			sql := sql + ' SELECT COUNT(id)';
			sql := sql + ' FROM labgrp';
			sql := sql + ' WHERE sumfound > 0 and sumnotfound = 0';
			Value := Geoget_DB.GetTableValue(sql);
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Micro Cacher
		'Micr': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Small Cacher
		'Smal': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Regular Cacher
		'Regu': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Large Cacher
		'Larg': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//
		'Odds': begin
			aStr := BG.GlobalVariables;
			Value := StrToInt64(GlobalVarGet(Fetch(aStr,'|'),false));				//Other
			Value := Value + StrToInt64(GlobalVarGet(Fetch(aStr,'|'),false));		//Not chosen
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Adventurous Cacher
		'Five': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			Points := Value;
			if Points > 5 then Points := 5;
		end;
		//The Lazy Cacher
		'Lazy': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Wheelchair Accesibled Cacher
		'Wheel': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Brainiac
		'Difi': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Rugged Cacher
		'Terr': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Matrix Cacher
		'Matr': begin
			Points := 0; j := 0;
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			if Value > 40 then Points := (Value - 40) * 0.5;
			if Value = 81 then begin
				Points := Points + 10;
				Inc(j);						//1
			end;
			//Repeat diamond badge
			if j > 0 then begin 
				For i := 1 to 9 do begin
			  		sql := 'SELECT COUNT(t.[combination]) FROM';
			  		sql := sql + ' (SELECT TRIM(CAST(CAST(gc.terrain as money) AS TEXT))||trim(CAST(CAST(gc.difficulty as money) AS TEXT)) combination';
					sql := sql + ' FROM geocache gc';
					sql := sql + ' WHERE gc.dtfound > 0';
					sql := sql + ' and gc.cachetype<>"Lab Cache"'
					sql := sql + ' and (CAST(gc.terrain AS MONEY) > 0 AND CAST(gc.terrain AS MONEY) < 5.1)';
					sql := sql + ' and (CAST(gc.difficulty AS MONEY) > 0 AND CAST(gc.difficulty AS MONEY) < 5.1)';
					sql := sql + ' GROUP BY combination';
					sql := sql + ' HAVING COUNT(gc.id) > ' + IntToStr(i) + ') t';
					//
					Value := Geoget_DB.GetTableValue(sql);
					if Value = 81 then Inc(j)
					else begin
						val := Value;
						Break;
					end;
				end;
			end;
			//BP
			if (j > 9) and (CalcBG_INI.bBlackPearl) then begin	//BP
				BG.Optional := '[(10X) - Ten caches with same combination]';
				BG.Flags := BG.Flags + 'BC';			//dopln?m flag BP a koment  
			end;
			//
			if j > 0 then Value := 81*j + val;
			//
			//Value := 165; //Test
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Diverse Cacher
		'Uniq': begin
			Points := 0;
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not((BgIdx = '') {or (BgIdx = 'Gray')}) then Points := Value * 2;
		end;
		//The FTF Addict
		'FTF': begin
			Points := 0;
			Value :=  StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not((BgIdx = '') {or (BgIdx = 'Gray')}) then Points := Value * 0.5;
			if Points > 30 then Points := 30;
		end;
		//The Cacher on Winners Pedestal
		'WPed': begin
			aStr := BG.GlobalVariables;
			Value := StrToInt64(GlobalVarGet(Fetch(aStr,'|'),false));				//FTF
			Value := Value + StrToInt64(GlobalVarGet(Fetch(aStr,'|'),false));		//STF
			Value := Value + StrToInt64(GlobalVarGet(Fetch(aStr,'|'),false));		//TTF
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Cache Owner
		'Hidd': begin
			//Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));	//P vodn  jen cache, te  sou et v eho
			Value := StrToInt64(GlobalVarGet('Calc_OwnedCount',false)) + StrToInt64(GlobalVarGet('Calc_EventHostCount',false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Event Host
		'Host': begin
			Points := 0;
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not((BgIdx = '') {or (BgIdx = 'Gray')}) then Points := Value * 2;
			if Points > 30 then Points := 30;
		end;
		//Head-In-The-Clouds Award
		'Elev': begin
			Value := Round(StrToFl(GlobalVarGet(BG.GlobalVariables,false)));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Head-In-The-Ground Award
		'Lowe': begin
			Value := Round(StrToFl(GlobalVarGet(BG.GlobalVariables,false)));
			if Value >= 0 then Value := 0
			else Value := Value*(-1) ;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Highlander Cacher
		'High': begin
			sql := 'SELECT COUNT(gc.id) cnt, group_concat(gc.id,'','') ids, MAX(CAST(gtv.value AS INT)) high';
			sql := sql + ' FROM geocache gc';
			sql := sql + ' INNER JOIN geotag gt ON (gc.id = gt.id AND gt.ptrkat IN';
			sql := sql + ' (SELECT key FROM geotagcategory WHERE value = ''Elevation'' COLLATE NOCASE))';
			sql := sql + ' INNER JOIN geotagvalue gtv ON (gt.ptrvalue IN (gtv.[key]))';
			sql := sql + ' WHERE gc.dtfound > 0 AND CAST(gtv.value AS INT) >= 1000';  //v??ce jak 1000 m.n.m
			//sql := sql + ' AND  gc.[cachetype] not in (''Giga-Event Cache'',''Mega-Event Cache'',''Event Cache'',''Cache In Trash Out Event'',''Lost and Found Event Cache'')';
			table := GEOGET_DB.GetTable(sql, false);
			//
			try
				Value := table.FieldAsInteger(0);
				Log('Highlander 1000: ' + table.FieldAsString(1));
				aStr := 'caches 1000 m.a.s.l. and higher';
			finally
				table.Free;
			end;
			//BP
			val := Value;
			if (Value > BG.Limits[7]) and (CalcBG_INI.bBlackPearl) then begin
				sql := ReplaceString(sql,'1000','1500');			//v??ce jak 1500 m.n.m
				table := GEOGET_DB.GetTable(sql, false);
				//
				try
					Value := table.FieldAsInteger(0);
					Log('Highlander 1500: ' + table.FieldAsString(1));
				finally
					table.Free;
				end;
				if Value >= BG.Limits[7] then begin
					aStr := 'caches 1500 m.a.s.l. and higher';
					BG.Flags := BG.Flags + 'B';				//dopln?m flag BP
				end;
				//else Value := val;
			end;
			Value := val;
			//
			BG.Optional := '[' + aStr + ']';
			BG.Flags := BG.Flags + 'C';						//zavedu koment??
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Travelling Cacher
		'Coun': begin
			sql := 'select count(*) from (select count(*) from geocache gc where gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES+' group by gc.country)';
			Value := Geoget_DB.GetTableValue(sql);
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Busy Cacher
		'Twen': begin
			Points := 0;
			sql := 'select max(cnt) from (select count(gc.dtfound) cnt from geocache gc where gc.dtfound>0 group by gc.dtfound)';
			Value := Geoget_DB.GetTableValue(sql);
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not((BgIdx = '') {or (BgIdx = 'Gray')}) then Points := (Value div 50) * 10;
			if Points > 40 then Points := 40;
		end;
		//The Daily Cacher
		'Cons': begin
			Points := 0;
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG.Optional := '[' + GlobalVarGet('Calc_FoundStreakDailyFrom',false) + ' - ' + GlobalVarGet('Calc_FoundStreakDailyTo',false) + ']';
			//	
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not((BgIdx = '') {or (BgIdx = 'Gray')}) then Points := (Value div 7) * 0.5;
			if Value >= 366 then Points := Points + 10;
		end;
		//The Challenge cacher
		'Chal': begin
			sql:='SELECT count(*) cnt FROM geocache gc WHERE gc.cachetype = "Unknown Cache" AND gc.name LIKE "%challenge%" AND gc.dtfound <> 0';
			if Trim(CalcBG_INI.sNoChallenge) <> '' then begin
				sql:=sql+' AND gc.id not in ('+Trim(CalcBG_INI.sNoChallenge)+')';
			end;
			Value := Geoget_DB.GetTableValue(sql);
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Jasmer Cacher
		'Jasmer': begin
			val := 0; 
			cnt:=8+(StrToInt(FormatDateTime('yyyy',Now()))-2001)*12+(StrToInt(FormatDateTime('m',Now()))-1);
			for i := 0 to 8 do begin
				sql:='SELECT COUNT(y.rok_mes) FROM(SELECT count(rok_mes) pocet, rok_mes FROM (SELECT substr(dthidden,1,4)||";"||substr(dthidden,5,2) as rok_mes FROM geocache gc WHERE gc.dtfound>0 AND substr(gc.id,1,2)="GC") x group by rok_mes order by rok_mes) y WHERE y.pocet > ' + IntToStr(i);
				j := Geoget_DB.GetTableValue(sql);
				if (val = j) or (val = 0) then begin
					val := j;
					Value := Value + val;
				end
				else begin
					if (Value mod cnt) = 0 then Value := Value + val;
					break;
				end;
			end;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Calendar Cacher
		'Cale': begin
			Points := 0; j := 0;
			sql := 'select count(*) from (select substr(CAST(gc.dtfound AS text),5)';
			sql := sql + ' from geocache gc where gc.dtfound>0 group by substr(CAST(gc.dtfound AS text),5))';
			//
			Value := Geoget_DB.GetTableValue(sql);
			if Value > 100 then Points := Value * 0.08;			//Body
			if Value = 366 then Inc(j);							//1 level
			//Repeat diamond badge
			if j > 0 then begin 
				For i := 1 to 9 do begin
			  		sql := 'select count(*) from (select substr(CAST(gc.dtfound AS text),5)';
					sql := sql + ' from geocache gc where gc.dtfound>0 group by substr(CAST(gc.dtfound AS text),5)';
					sql := sql + ' having count(gc.id) > ' + IntToStr(i) + ')';
					//
					Value := Geoget_DB.GetTableValue(sql);
					if Value = 366 then Inc(j)
					else begin
						val := Value;
						Break;
					end;
				end;
			end;
			//BP
			if (j > 9) and (CalcBG_INI.bBlackPearl) then begin	//BP
				BG.Optional := '[(10X) - Ten caches a calendar''s day]';
				BG.Flags := BG.Flags + 'BC';			//dopln?m flag BP a koment  
			end;
			//
			if j > 0 then Value := 366*j + val;
			//
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Scuba-Cacher
		'Unde': begin
			Value := CalcBG_INI.iWaterCaches;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Long-Distance Cacher
		'Dist': begin
			Points := 0;
			sql := 'SELECT st.[distance], st.[id]';
			sql := sql + ' FROM '+TEMP_TABLE+' st, geocache gc WHERE gc.id = st.id AND gc.[id] not in (' + sIgnoreCaches + ')';
			sql := sql + CONST_SQL_IGNORE_CACHETYPES;
			table := GEOGET_DB.GetTable(sql, false);
			//
			try
				eLong := 0; eLongMax := 0; aStr := '';
				while not table.Eof do begin
					eLong := table.FieldAsDouble(0);
					if eLong > eLongMax then begin
						eLongMax := eLong;					//Max
						aStr := table.FieldAsString(1);		//ID
					end;
					table.Next;
				end;
				Value := Round(eLongMax); Points := 0;
				BG.Optional := '[' + aStr + ']';
			finally
				if(table <> nil) then table.Free;
			end;
			//
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Bearing Cacher
		'Bear': begin
			Points := 0; j := 0;
			sql := 'SELECT COUNT(*) cnt FROM (SELECT DISTINCT CAST(st.[angle] AS INTEGER)';
			sql := sql + ' FROM '+TEMP_TABLE+' st, geocache gc WHERE gc.id = st.id AND gc.[id] not in (' + sIgnoreCaches + ')';
			sql := sql + CONST_SQL_IGNORE_CACHETYPES+')';
			//
			Value := Geoget_DB.GetTableValue(sql);
			//
			if Value = 360 then Inc(j);							//1 level
			//Repeat diamond badge
			if j > 0 then begin 
				For i := 1 to 9 do begin
			  		sql := 'SELECT COUNT(t.iangle) cnt FROM (SELECT CAST(st.[angle] AS INTEGER) iangle';
					sql := sql + ' FROM '+TEMP_TABLE+' st, geocache gc WHERE gc.id = st.id AND gc.[id] not in (' + sIgnoreCaches + ')';
					sql := sql + CONST_SQL_IGNORE_CACHETYPES;
					sql := sql + ' GROUP BY iangle HAVING COUNT(st.id) > ' + IntToStr(i) + ') t';
					//
					Value := Geoget_DB.GetTableValue(sql);
					if Value = 360 then Inc(j)
					else begin
						val := Value;
						Break;
					end;
				end;
			end;
			//BP
			if (j > 9) and (CalcBG_INI.bBlackPearl) then begin	//BP
				BG.Optional := '[(10X) - Ten caches a 1' + chr(176) + ']';
				BG.Flags := BG.Flags + 'BC';			//dopln?m flag BP a koment
			end;
			//
			if j > 0 then Value := 360*j + val;
			//
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//
		'Tlov': begin
			Value := Round(StrToFl(GlobalVarGet(BG.GlobalVariables,false)));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not (BgIdx = '') then Points := Points + (Value * 0.05);	
		end;
		//The Travel Bug
		{'Trav': begin
			Points := 0;
			PreValue := CalcBG_INI.iAllTB; 
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			if Value = 0 then Value := PreValue;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not((BgIdx = '')) then Points := Points + (Value * 0.05);
			//if Points > 25 then Points := 25;
		end;}
		//The Coin Collector
		{'Coin': begin
			Points := 0;
			PreValue := CalcBG_INI.iAllGC; 
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			if Value = 0 then Value := PreValue;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not((BgIdx = '')) then Points := Points + (Value * 0.05);
			//if Points > 25 then Points := 25;
		end;}
		//The CWG Collector
		'CWG': begin
			Value := CalcBG_INI.iAllCWG;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Author
		'Author': begin
			Value := Round(StrToFl(GlobalVarGet(BG.GlobalVariables,false)));
			try
				Value := Value/(StrToInt64(GlobalVarGet('FoundCachesCount',false))-StrToInt64(GlobalVarGet('Calc_CacheLabCount',false)));
			except
				Value := 0;
			end;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The QTH Locator Cacher
		'QTH': begin
			sql := 'SELECT COUNT(DISTINCT gv.value) AS QTHFOUNDALLCNT';
			sql := sql + ' FROM geocache gc';
			sql := sql + ' INNER JOIN geotag gt ON gt.id = gc.id';
			sql := sql + ' INNER JOIN geotagcategory gtc ON gtc.key = gt.ptrkat AND gtc.value = "QTHLocator"';
			sql := sql + ' INNER JOIN geotagvalue gv ON gv.key = gt.ptrvalue';
			sql := sql + ' WHERE gc.dtfound > 0' + CONST_SQL_IGNORE_CACHETYPES;
			if Trim(CalcBG_INI.sNoQTH) <> '' then begin
				sql:=sql+' AND gc.id NOT IN ('+Trim(CalcBG_INI.sNoQTH)+')';
			end;
			//----
			Value := Geoget_DB.GetTableValue(sql);
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Caching Veteran
		'Vete': begin
			Points := 0;
			Value :=  StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			if not((BgIdx = '') {or (BgIdx = 'Gray')}) then Points := Value * 2;
		end;
		//The Night-Owl
		'NightOwl': begin
			Value := CalcBG_INI.iNight;
			if Value = 0 then begin
				if CalcBG_INI.iNightTAG = '' then
					Value := Geoget_DB.GetTableValue(BG_tagSQL('E','attribute','nightcache-yes'))
				else 
					Value := Geoget_DB.GetTableValue(BG_tagSQL('T',CalcBG_INI.iNightTAG,''));
			end;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Night Cacher
		'DayNight': begin
			Value := Geoget_DB.GetTableValue(BG_tagSQL('E','SvetloTma','Tma'));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Shutterbug
		'Phot': begin
			Points := 0;
			PreValue := CalcBG_INI.iPhotos;
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			if Value = 0 then Value := PreValue;
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			Points := Value * 0.1;
			if Points > 25 then Points := 25;
		end;
		//State Badges
		'States': begin
			value_sl := TStringList.Create;
			aParams := TStringList.Create;
			aParams.CommaText := BG.Optional;
			//
			BG.Optional := '';
			Points := 0;
			BG.ShortName := aParams.Values['Base'];
			try
				sState := ReplaceString(aParams.Values['State'], '~', ' ');
				//Log('State --> '+sState);
				sTag := ReplaceString(aParams.Values['Tag'], '~', ' ');
				//Log('Tag --> '+sTag);
				//Limit correction to Real
				if CalcBG_INI.bIsOriginal then lmt := BG.Limits			//Limit klasika
				else lmt := BG.LimitsEU;								//Limit EU
				dis := StrToInt(aParams.Values['Districts']);			//Districts (100%)
				for j := 0 to 7 do begin
					val := Round((dis*lmt[j]/100.00)+0.01);
					if val = 0 then val := 1;							//Nejmen?? je 1
					RealLimit[j] := val;
				end;
				//	
				if aParams.Values['Tag'] = '-' then begin					
					//SQL
					sql := 'select CAST(CAST(round((ctr.cnt*100.00)/' + aParams.Values['Districts'] + ',2) as money) as varchar)||", "||';
					sql := sql + 'CAST(ctr.cnt as varchar)||", "||CAST(ctr.country as varchar)||", "||CAST(ctr.states as varchar)';
					sql := sql + ' from (';
					sql := sql + ' select country, max(cnt) as cnt, group_concat(states," + ") as states from (';
					sql := sql + ' select country,1 as cnt,''?'' as states from geocache where dtfound>0 and state='''' group by country';
					sql := sql + ' union';
					sql := sql + ' select country, count(state) as cnt, group_concat(state,", ") as states from (';
					sql := sql + ' select country,state from geocache where dtfound>0 and state!="" group by country,state'
					sql := sql + ') group by country order by states asc';
					sql := sql + ') group by country';
					sql := sql + ') ctr where ctr.country = "' + sState + '"';
					//sql := sql + ' order by ctr.country';
					{$ifdef DEBUG_HELPER} LDH('SQL:'+sql); {$endif}
					try
						aStr := UtfToAnsi(GEOGET_DB.GetTableString(sql));
						Log('##> '+aStr);
						while aStr <> '' do begin
							value_sl.Add(Fetch(aStr,','));
						end;
					except
						value_sl.clear;
					end;
					//
					if Trim(value_sl.text) <> '' then begin
						for j := 3 to value_sl.count-1 do BG.Optional := BG.Optional + value_sl[j] + ', ';
						BG.Optional := '[' + BG.Optional + ' ' + value_sl[1] + '/' + aParams.Values['Districts'] + ']';
						BG.Name := 'The ' + UtfToAnsi(value_sl[2]) + ' Cacher';
						RealName := BG.Name;
						//Vytvo?? odznak
						Value := Round(StrToFl(value_sl[1]));	//Round(StrToFl(value_sl[0]));
						BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);	
						if not((BgIdx = '') {or (BgIdx = 'Gray')}) then Points := 1;
					end
					else begin
						log(sState+' Error! - error in country badge.');
						Value := 1;
						BG.ShortName := 'Err';
						BG.Name := sState + ' Error! ';
						BG.Flags := 'L';	//Veme se p??mo RealLimit
						RealLimit[0] := 1; RealLimit[1] := 1; RealLimit[2] := 1; RealLimit[3] := 1; RealLimit[4] := 1; RealLimit[5] := 1; RealLimit[6] := 1; RealLimit[7] := 1;
						BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
					end;
				end
				else begin
					//SQL
					sql := 'select gc.country as country, "?" as state, count(country) as cnt';
					sql := sql + ' from geocache gc';
					sql := sql + ' left join geotag gt on (gc.id = gt.id and gt.ptrkat IN (select key from geotagcategory where value = "' + sTag + '" COLLATE NOCASE))';
					sql := sql + ' where dtfound>0 and gt.ptrvalue = null';
					sql := sql + ' group by gc.country';
					sql := sql + ' union';
					sql := sql + ' select gc.country, Trim(gv.value) as state, count(Trim(gv.value)) as cnt';
					sql := sql + ' from geocache gc';
					sql := sql + ' inner join geotag gt ON gt.id = gc.id and gt.ptrkat IN (select key from geotagcategory where value = "' + sTag + '" COLLATE NOCASE)';
					sql := sql + ' inner join geotagvalue gv ON gv.key = gt.ptrvalue';
					sql := sql + ' where gc.dtfound>0 and gc.country = "' + sState + '" and state is not null';
					sql := sql + ' group by gc.country, Trim(gv.value)';
					//
					{$ifdef DEBUG_HELPER} LDH('SQL:'+sql); {$endif}
					table := GEOGET_DB.GetTable(sql, false);
					//
					try
						cnt := 0;
						while not table.Eof do begin
							aStr := UtfToAnsi(table.FieldAsString(1));
							Log('##>> '+aStr);
							correct := true;
							//nepochopitelna oprava - obcas se nektere kraje zdvoji ?!?!--------------------
							if Trim(value_sl.text) <> '' then begin						
								for j := 0 to value_sl.count-1 do begin
									if aStr = value_sl[j] then begin
										correct := false;
										break;
									end;
								end;
							end;
							//
							if correct then begin
								if aStr <> '?' then Inc(cnt);
								value_sl.Add(aStr);
							end;
							//------------------------------------------------------------------------------
							table.Next;
						end;
					finally
						if(table <> nil) then table.Free;
					end;
					//
					if Trim(value_sl.text) <> '' then begin
						for j := 0 to value_sl.count-1 do BG.Optional := BG.Optional + value_sl[j] + ', ';
						BG.Optional := '[' + BG.Optional + ' ' + IntToStr(cnt) + '/' + aParams.Values['Districts'] + ']';
						BG.Name := 'The ' + sState + ' Cacher';
						RealName := BG.Name;
						//Vytvo?? odznak
						Value := cnt; //Round(cnt*100.00/StrToInt(aParams.Values['Districts']));
						BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
						if not((BgIdx = '') {or (BgIdx = 'Gray')}) then Points := 1;	
					end
					else begin
						log(sState + ' Error! - Missing TAG in Badges.CountOfRegions.ini - "' + sTag + '" or another error.');
						Value := 1;
						BG.ShortName := 'Err';
						BG.Flags := 'L';	//Veme se p??mo RealLimit
						BG.Name := sState + ' Error! ';
						RealLimit[0] := 1; RealLimit[1] := 1; RealLimit[2] := 1; RealLimit[3] := 1; RealLimit[4] := 1; RealLimit[5] := 1; RealLimit[6] := 1; RealLimit[7] := 1;
						BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
					end;
				end;
			finally
				value_sl.Free;
				aParams.Free;
			end;
		end;
		//The Favourite Cacher
		'Favo': begin
			Value := StrToInt64(GlobalVarGet(BG.GlobalVariables,false));
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
			Points := Value * 0.1;
		end;
		//The Europe Cacher (upraveno 2018)
		'Evro': begin
			sql := 'select CAST(count(cnt.country) as varchar)||'', ''||CAST(group_concat(cnt.country, '', '') as varchar)';
			sql := sql + ' from';
			sql := sql + ' (select gc.country as country';
			sql := sql + ' from geocache gc';
			sql := sql + ' where gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES;
			sql := sql + ' and gc.country in ('+GetStatesGroupData(ID)+')';
			sql := sql + ' group by gc.country) as cnt';
			{$ifdef DEBUG_HELPER} LDH('SQL:'+sql); {$endif}
			aStr := Geoget_DB.GetTableString(sql);
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + UtfToAnsi(bStr) + ' ' + IntToStr(Value) + '/52]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The EU Cacher (upraveno 2017)
		'EUR': begin
			sql := 'select CAST(count(cnt.country) as varchar)||'', ''||CAST(group_concat(cnt.country, '', '') as varchar)';
			sql := sql + ' from';
			sql := sql + ' (select gc.country as country';
			sql := sql + ' from geocache gc';
			sql := sql + ' where gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES;
			sql := sql + ' and gc.country in ('+GetStatesGroupData(ID)+')';
			sql := sql + ' group by gc.country) as cnt';
			{$ifdef DEBUG_HELPER} LDH('SQL:'+sql); {$endif}
			aStr := Geoget_DB.GetTableString(sql);
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + UtfToAnsi(bStr) + ' ' + IntToStr(Value) + '/28]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Asia Cacher (upraveno 2018)
		'Asia': begin
			sql := 'select CAST(count(cnt.country) as varchar)||'', ''||CAST(group_concat(cnt.country, '', '') as varchar)';
			sql := sql + ' from';
			sql := sql + ' (select gc.country as country';
			sql := sql + ' from geocache gc';
			sql := sql + ' where gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES;
			sql := sql + ' and gc.country in ('+GetStatesGroupData(ID)+')';
			sql := sql + ' group by gc.country) as cnt';
			{$ifdef DEBUG_HELPER} LDH('SQL:'+sql); {$endif}
			aStr := Geoget_DB.GetTableString(sql);
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + UtfToAnsi(bStr) + ' ' + IntToStr(Value) + '/52]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Africa Cacher (upraveno 2018)
		'Afri': begin
			sql := 'select CAST(count(cnt.country) as varchar)||'', ''||CAST(group_concat(cnt.country, '', '') as varchar)';
			sql := sql + ' from';
			sql := sql + ' (select gc.country as country';
			sql := sql + ' from geocache gc';
			sql := sql + ' where gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES;
			sql := sql + ' and gc.country in ('+GetStatesGroupData(ID)+')';
			sql := sql + ' group by gc.country) as cnt';
			{$ifdef DEBUG_HELPER} LDH('SQL:'+sql); {$endif}
			aStr := Geoget_DB.GetTableString(sql);
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + UtfToAnsi(bStr) + ' ' + IntToStr(Value) + '/59]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The America Cacher (upraveno 2018)
		'Amer': begin
			sql := 'select CAST(count(cnt.country) as varchar)||'', ''||CAST(group_concat(cnt.country, '', '') as varchar)';
			sql := sql + ' from';
			sql := sql + ' (select gc.country as country';
			sql := sql + ' from geocache gc';
			sql := sql + ' where gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES;
			sql := sql + ' and gc.country in ('+GetStatesGroupData(ID)+')';
			sql := sql + ' group by gc.country) as cnt';
			{$ifdef DEBUG_HELPER} LDH('SQL:'+sql); {$endif}
			aStr := Geoget_DB.GetTableString(sql);
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + UtfToAnsi(bStr) + ' ' + IntToStr(Value) + '/60]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Australia Cacher (upraveno 2018)
		'Aust': begin
			sql := 'select CAST(count(cnt.country) as varchar)||'', ''||CAST(group_concat(cnt.country, '', '') as varchar)';
			sql := sql + ' from';
			sql := sql + ' (select gc.country as country';
			sql := sql + ' from geocache gc';
			sql := sql + ' where gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES;
			sql := sql + ' and gc.country in ('+GetStatesGroupData(ID)+')';
			sql := sql + ' group by gc.country) as cnt';
			{$ifdef DEBUG_HELPER} LDH('SQL:'+sql); {$endif}
			aStr := Geoget_DB.GetTableString(sql);
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + UtfToAnsi(bStr) + ' ' + IntToStr(Value) + '/26]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;				
		//The CZ District Cacher
		'CZDist': begin
			sql := 'SELECT CAST(count(result.name) as varchar)||", "||CAST(group_concat(result.name, ", ") as varchar)';
			sql := sql + ' FROM (SELECT DISTINCT (SELECT CASE WHEN (value LIKE "Praha %") THEN "Praha" ELSE value END val';
			sql := sql + ' FROM geotagvalue WHERE key = gt.ptrvalue) name'; 
			sql := sql + ' FROM (SELECT *';
			sql := sql + ' FROM geocache gc';
			sql := sql + ' WHERE gc.dtfound > 0) f';
			sql := sql + ' INNER JOIN geotag gt on (f.id = gt.id and gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "CZ okres" COLLATE NOCASE))';
			sql := sql + ' GROUP BY ptrvalue';
			sql := sql + ' ORDER BY name COLLATE NOCASE) result';
			aStr := UtfToAnsi(GEOGET_DB.GetTableString(sql));
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + bStr + ' ' + IntToStr(Value) + '/77]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The SK District Cacher
		'SKDist': begin
			sql := 'SELECT CAST(count(result.name) as varchar)||'', ''||CAST(group_concat(result.name, ", ") as varchar)';
			sql := sql + ' FROM (SELECT (SELECT value FROM geotagvalue WHERE key = gt.ptrvalue) name';
			sql := sql + ' FROM (SELECT *';
			sql := sql + ' FROM geocache gc';
			sql := sql + ' WHERE gc.dtfound > 0) f';
			sql := sql + ' INNER JOIN geotag gt on (f.id = gt.id and gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "SK okres" COLLATE NOCASE))';
			sql := sql + ' GROUP BY ptrvalue';
			sql := sql + ' ORDER BY name COLLATE NOCASE) result';
			aStr := UtfToAnsi(GEOGET_DB.GetTableString(sql));
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + bStr + ' ' + IntToStr(Value) + '/79]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The AT Bezirk Cacher
		'ATBez': begin
			sql := 'SELECT CAST(count(result.name) as varchar)||'', ''||CAST(group_concat(result.name, ", ") as varchar)';
			sql := sql + ' FROM (SELECT (SELECT value FROM geotagvalue WHERE key = gt.ptrvalue) name';
			sql := sql + ' FROM (SELECT *';
			sql := sql + ' FROM geocache gc';
			sql := sql + ' WHERE gc.dtfound > 0) f';
			sql := sql + ' INNER JOIN geotag gt on (f.id = gt.id and gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "AT Bezirk" COLLATE NOCASE))';
			sql := sql + ' GROUP BY ptrvalue';
			sql := sql + ' ORDER BY name COLLATE NOCASE) result';
			aStr := UtfToAnsi(GEOGET_DB.GetTableString(sql));
			bStr := '';
			Value := Round(StrToFl(Fetch(aStr,',')));
			while aStr <> '' do begin
				bStr := bStr + Fetch(aStr,',') + ', ';
			end;
			BG.Optional := '[' + bStr + ' ' + IntToStr(Value) + '/95]';
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Waymarker
		'Waym': begin
			sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.id like ''WM%''';
			if not CalcBG_INI.bIsOriginal then BG.Name := BG.Name + ' CZ';
			if (CalcBG_INI.DruhaDB <> nil) then
				Value := CalcBG_INI.DruhaDB.GetTableValue(sql)
			else
				Value := GEOGET_DB.GetTableValue(sql);
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Waymark Author
		'WMaut': begin
			sql := 'select count(gc.id) from geocache gc';
			sql := sql + ' where gc.author LIKE ''%' + GlobalVarGet('GeogetOwner',false) + '%'' and gc.id LIKE ''WM%''';
			if (CalcBG_INI.DruhaDB <> nil) then
				Value := CalcBG_INI.DruhaDB.GetTableValue(sql)
			else
				Value := GEOGET_DB.GetTableValue(sql);
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		//The Waymark categories discoverer
		'WCat': begin
			sql := 'select count(ctype) result';
			sql := sql + ' from (';
			sql := sql + ' select distinct ctype';
			sql := sql + ' from (';
			sql := sql + ' select gc.[cachetype] ctype';
			sql := sql + ' from geocache gc';
			sql := sql + ' where dtfound > 0 and gc.id LIKE ''WM%''';
			sql := sql + ' union all';
			sql := sql + ' select gc.[cachetype] ctype';
			sql := sql + ' from geocache gc';
			sql := sql + ' where gc.author LIKE ''%' + GlobalVarGet('GeogetOwner',false) + '%'' and gc.id LIKE ''WM%'')';
			sql := sql + ' order by ctype)';
			if (CalcBG_INI.DruhaDB <> nil) then
				Value := CalcBG_INI.DruhaDB.GetTableValue(sql)
			else
				Value := GEOGET_DB.GetTableValue(sql);
			BG_ResultBadge(BG, Value, BgIdx, BgHtml, InfHtml, percent, ImgN);
		end;
		else Result := false;
	end;
	//
	if Pos('S',BG.Flags) > 0 then ID := 'States';		//Zarazeni mezi States
end;

function CWGgcmGetData(): integer;
var
	stmp,sa,sb	: String;
begin
	Result := -1;
	if HttpAsk('GET', CalcBG_sGCM + ReplaceString(CalcBG_INI.sCWGgcmLogin,' ','%20'), '', '', stmp) then begin
                log('GCM:' + stmp);
		stmp := ReplaceString(Trim(ReplaceString(ReplaceString(stmp,'{',''),'}','')),'"','');
		sa := Fetch(stmp,':');
		sa := Fetch(stmp,',');
		if Lowercase(sa) = 'true' then begin
			sb := Fetch(stmp,':');
			sb := Fetch(stmp,',');
			sb := Fetch(stmp,':');
			//
			Result := StrToInt(stmp);
			Log('CWG.gcm: '+stmp);
		end;
	end;
end;

procedure BG_GetSetting(aPar: TStringList);
var
	{tmpURL,}tmp, msg, ddir  : String;
	CWGDB     : TSqliteDatabase;
begin
	if aPar<>nil then
	begin
		log('CalcBG start with parameters');
		CalcBG_INI.bIsOriginal 		:= aPar.Values['Original'] = 'Yes';
		//
		CalcBG_INI.iWaterCaches 	:= StrToIntDef(aPar.Values['WaterCaches'],0);
		CalcBG_INI.iBenchmark		:= StrToIntDef(aPar.Values['NGS'],0);
		CalcBG_INI.iPhotos			:= StrToIntDef(aPar.Values['Photos'],0);
		CalcBG_INI.iNight			:= StrToIntDef(aPar.Values['NightCaches'],0);
		CalcBG_INI.iNightTAG		:= aPar.Values['NightCachesTag'];
		//CalcBG_INI.iAllTB			:= StrToInt(aPar.Values['TBs']);
		//CalcBG_INI.iAllGC			:= StrToInt(aPar.Values['GCs']);
		tmp                         := aPar.Values['CWGMethod'];
		CalcBG_INI.sCWGMethod       := Trim(Fetch(tmp,'-'));
		CalcBG_INI.iAllCWG			:= StrToIntDef(aPar.Values['CWGs'],0);
		CalcBG_INI.sCWGgcmLogin		:= aPar.Values['CWGgcmLogin'];
		CalcBG_INI.sCWGextDB        := aPar.Values['CWGlocalDB'];
		CalcBG_INI.sCWGextDBSelect  := aPar.Values['CWGlocalDBSQL'];
		//Manual
		if CalcBG_INI.sCWGMethod = 'Manually' then Log(CalcBG_INI.sCWGMethod);
		//Vytazeni CWG z NIXOVA cwg.gcm.cz---------------------------------------------
		if CalcBG_INI.sCWGMethod = 'GCM' then begin
			Log(CalcBG_INI.sCWGMethod);
			if CalcBG_INI.sCWGgcmLogin	<> '' then begin
			  CalcBG_INI.iCWGgcm := 0;
			  CalcBG_INI.iCWGgcm := CWGgcmGetData;
			  if CalcBG_INI.iCWGgcm > 0 then CalcBG_INI.iAllCWG := CalcBG_INI.iCWGgcm;
			end;
		end;
		//Vytazeni CWG z externi? DB----------------------------------------------------
		if CalcBG_INI.sCWGMethod = 'Local DB' then begin
			Log(CalcBG_INI.sCWGMethod);
			if (CalcBG_INI.sCWGextDB	<> '') and (CalcBG_INI.sCWGextDBSelect	<> '')then begin
			  // 
			  if FileExists(CalcBG_INI.sCWGextDB) then ddir := CalcBG_INI.sCWGextDB      //Libovoln  adres  
			  else if FileExists(GEOGET_DATADIR + '\' + CalcBG_INI.sCWGextDB) then 
				ddir := GEOGET_DATADIR + '\' + CalcBG_INI.sCWGextDB                       //Datadir
			  else ddir := GEOGET_SCRIPTDIR+ '\' + CalcBG_INI.sCWGextDB;                  //Scriptdir
			  if FileExists(ddir) then begin
				CalcBG_INI.iCWGDB := 0;
				CWGDB := TSqliteDatabase.Create(ddir);
				try
				  //Call DB
				  try
					if (CWGDB <> nil) then CalcBG_INI.iCWGDB := CWGDB.GetTableValue(CalcBG_INI.sCWGextDBSelect);
				  except
					msg := 'ERR: '+_('Wrong query to the database:')+' '+CalcBG_INI.sCWGextDB
					  +CRLF+CalcBG_INI.sCWGextDBSelect;
					Log(msg);
				  end;
				finally
				  CWGDB.Free();
				end;
				if CalcBG_INI.iCWGDB > 0 then CalcBG_INI.iAllCWG := CalcBG_INI.iCWGDB;
			  end
			  else begin
				Log(_('ERR: There is no database for CWG:')+' '+ddir+'!');
			  end;
			end;
		end;
		//-----------------------------------------------------------------------------
		//
		CalcBG_INI.bWaymarking		:= aPar.Values['WaymarkingBG'] = 'Yes';
		CalcBG_INI.bBlackPearl		:= aPar.Values['BlackPearl'] = 'Yes';
		//
		CalcBG_INI.sWaymarkingDB	:= aPar.Values['WaymarkingDB'];
		if (CalcBG_INI.bWaymarking) and not 
		   (FileExists(GEOGET_DATADIR + '\' + CalcBG_INI.sWaymarkingDB)) then begin
			Log('There is no database for Waymarking: ' + CalcBG_INI.sWaymarkingDB
				+ ' badges for waymarking will not be created!');
			CalcBG_INI.bWaymarking := false;
		end;	
		//Challenge
		CalcBG_INI.sNoChallenge := aPar.Values['NoChallenge'];
		//QTH
		CalcBG_INI.sNoQTH := aPar.Values['NoQTH'];
		//URL
		//tmpURL		:= aPar.Values['ImagesURL'];
		//if tmpURL = 'GeoTrebic' then CalcBG_INI.sBadgesURL := 'http://www.geotrebic.cz/b/'
		//else CalcBG_INI.sBadgesURL := 'http://gc.zlej.net/b/';
		if (Trim(aPar.Values['AltImageURL'])='') then
			CalcBG_INI.sBadgesURL := CalcBG_sBadges
		else
			CalcBG_INI.sBadgesURL := Trim(aPar.Values['AltImageURL']);		
	end
	else begin
		log('CalcBG start automatically');
		CalcBG_INI.bIsOriginal 		:= false;			//Po  esku
		//
		CalcBG_INI.iWaterCaches 	:= 0;
		CalcBG_INI.iBenchmark		:= 0;
		CalcBG_INI.iPhotos			:= 0;
		CalcBG_INI.iNight			:= 0;
		CalcBG_INI.iNightTAG		:= '';
		//CalcBG_INI.iAllTB			:= 0;
		//CalcBG_INI.iAllGC			:= 0;
		CalcBG_INI.sCWGMethod     	:= 'Manually';		//Manualni? CWG
		CalcBG_INI.iAllCWG			:= 0;
		CalcBG_INI.sCWGgcmLogin		:= '';
		CalcBG_INI.sCWGextDB      	:= '';
		CalcBG_INI.sCWGextDBSelect 	:= '';
		//
		CalcBG_INI.bWaymarking		:= false;			//bez Waymarkingu
		CalcBG_INI.bBlackPearl		:= false;			//bez Cerne Perly
		//
		CalcBG_INI.sWaymarkingDB	:= '';
		//
		CalcBG_INI.sNoChallenge 	:= '';				//ke?e nepat??c? do Challenge
		CalcBG_INI.sNoQTH 			:= ''; 				//ke?e nepat??c? do QTH
		//URL
		CalcBG_INI.sBadgesURL := CalcBG_sBadges; 		//Odkaz na odznacky
	end;
end;

function CalcBG_Run(aPar: TStringList):String;
var
	i,j{,k,res}: integer;
	sql: String;
	table: TSQLiteTable;
	icnt: Int64;
	BGS: TBadgeDef;
	spomstate, spomtag, s: String;
	//SBGResult: array of TBGData;				//Pole pro st tn  odznaky
	//BGResult: TBGData;							//Ostatn  odznaky
	Idx, BGUrl, Info, RealName, BGoverlay: String;
	sActualDB, sTempDB, sNewDB: String;
	Pt: extended;
	Value: Int64;
	percent: integer;
begin
	Result := '';
	//Kontrola dvojiho spusteni
	if(CalcBG_sCalcRun='CALC') then begin
		Inc(nModuleErrors);
		iModuleError := 1;
		sModuleError := _('ERR: CalcBG double run!') + CRLF
					 + _('Does not make sense run the module CalcBG twice!');
		if(sModuleError <> '') then Log(sModuleError);
		exit;
	end;
	//Spoustim
	Log('Start CalcBG');
	CalcBG_sCalcRun := '';
	Result := '';
	//
	i:=CheckINI();
	if i <> 11 then
	begin
		Inc(nModuleErrors);
		iModuleError := i+100;
		if i = 0 then sModuleError := _('ERR: Missing file(s)')+' - Badges.CountOfRegions.ini, Badges.BGDefinitions.ini'
		else if i = 1 then sModuleError := _('ERR: Missing file(s)')+' - Badges.CountOfRegions.ini'
		else sModuleError := _('ERR: Missing file(s)')+' - Badges.BGDefinitions.ini';
		if(sModuleError <> '') then Log(sModuleError);
		bAbort:=true;
		exit;
	end;
	{if(aPar=nil) then begin
		Inc(nModuleErrors);
		iModuleError := 1;
		sModuleError := _('ERR: No input parameters!') + CRLF
					 + _('Weren''t forwarded to the input parameters can''t be processed calculation of badges');
		if(sModuleError <> '') then Log(sModuleError);
		exit;
	end;}
	//----------------------------------------------------------------------------------------------
	//registrovat fce
	GlobalVarRegisterReplaceFunction('CalcBG_GetData',@CalcBG_GetData);
	GlobalVarRegisterReplaceFunction('CalcBG_GetFlagData',@CalcBG_GetFlagData);
	//----------------------------------------------------------------------------------------------
	Log('Initializing CalcBG');
	BG_GetSetting(aPar);			//Nacte dulezite hodnoty pro fukci pluginu
	Log('BG Settings OK');
	BG_InitBadges();				//Inicializace pole odznacku
	Log('BG Array OK');
	//-------------------------------------------------------------------------
	//Druha DB-----------------------------------------------------------------
	//-------------------------------------------------------------------------
	if CalcBG_INI.bWaymarking then begin
		sActualDB := GEOGET_DBNAME;
		sTempDB := CalcBG_INI.sWaymarkingDB;
		sNewDB := Fetch(sTempDB,'.');
		if not ((sActualDB = sNewDB) or (sTempDB = '')) then begin
			CalcBG_INI.DruhaDB := TSqliteDatabase.Create(GEOGET_DATADIR + '\' + sNewDB + '.db3');
		end;
	end;
	//Projede a spocita hodnoty
	j := 0;
	SetLength(CalcBG_Data, High(CalcBG_Badges));		//nastavi pole odznaku
	For i := 0 to High(CalcBG_Badges) do
	begin
		if CalcBG_Badges[i].ShortName = 'States' then
		begin
				//Odznacky statu
				sql := 'SELECT Count(*) FROM (SELECT gc.[country] FROM geocache gc WHERE gc.[dtfound] > 0'+CONST_SQL_IGNORE_CACHETYPES+' GROUP BY gc.[country]);';
				icnt := GEOGET_DB.GetTableValue(sql);					//zjisti pocet statu
				SetLength(CalcBG_StateData, icnt);						//nastavi pole state odznaku
				sql := 'SELECT gc.[country] FROM geocache gc WHERE gc.[dtfound] > 0'+CONST_SQL_IGNORE_CACHETYPES+' GROUP BY gc.[country];';
				table := GEOGET_DB.GetTable(sql, false);
				try
					icnt := 0;
					while not table.Eof do begin
						//
						spomstate := UtfToAnsi(table.FieldAsString(0)); //table.FieldAsString(0);
						log('State: ' + spomstate);
						//btag := True;
						//
						BGS := CalcBG_Badges[i];
						BGS.Optional := 'Base=' + Trim(BG_iso2toiso3(GetCountryAbbr(spomstate))) + ',';
						BGS.Optional := BGS.Optional + 'State=' + ReplaceString(spomstate, ' ', '~') + ',';
						//
						spomtag := GetStateData(spomstate,'T');
						if spomtag <> '' then begin
							BGS.Optional := BGS.Optional + 'Tag=' + ReplaceString(SeparateLeft(spomtag,','), ' ', '~') + ',';
							BGS.Optional := BGS.Optional + 'Districts=' + SeparateRight(spomtag,',');
							log('Data T: ' + spomtag);
							//btag := False;
						end
						else begin
							s := GetStateData(spomstate,'S');
							BGS.Optional := BGS.Optional + 'Tag=' + '-' + ',';
							BGS.Optional := BGS.Optional + 'Districts=' + s;
							log('Data S: ' + s);
						end;
						//
						BG_Badge(BGS, Idx, BGUrl, Info, RealName, Pt, Value, percent, BGoverlay);			//spocita odznak
						//Result----------------------------
						CalcBG_StateData[icnt].Image := BGUrl;
						CalcBG_StateData[icnt].Info := Info;
						CalcBG_StateData[icnt].RealName := RealName;
						CalcBG_StateData[icnt].BadgeType := Idx;
						CalcBG_StateData[icnt].Value := Value;
						CalcBG_StateData[icnt].Points := 0;
						CalcBG_StateData[icnt].Percent := percent;
						CalcBG_StateData[icnt].Index := i;
						CalcBG_StateData[icnt].RealLimit := RealLimit;
						CalcBG_StateData[icnt].OverlayImg := BGoverlay;
						//----------------------------------
						Inc(icnt);
						table.Next;
					end;
					
				finally
					if(table <> nil) then table.Free;
				end;
		end
		else begin
			BG_Badge(CalcBG_Badges[i], Idx, BGUrl, Info, RealName, Pt, Value, percent, BGoverlay);
			//Result----------------------------
			CalcBG_Data[j].Image := BGUrl;
			CalcBG_Data[j].Info := Info;
			CalcBG_Data[j].RealName := '';
			CalcBG_Data[j].BadgeType := Idx;
			CalcBG_Data[j].Value := Value;
			CalcBG_Data[j].Points := Pt;
			CalcBG_Data[j].Percent := percent;
			CalcBG_Data[j].Index := i;
			CalcBG_Data[j].RealLimit := RealLimit;
			CalcBG_Data[j].OverlayImg := BGoverlay;
			//----------------------------------
			Inc(j);
		end;
	end;
	Result := '';
	//----------------------------------------
	//Free DB---------------------------------
	//----------------------------------------
	if (CalcBG_INI.DruhaDB <> nil) then CalcBG_INI.DruhaDB.Free();
	//----------------------------------------
	//----------------------------------------
	//----------------------------------------
	CalcBG_sCalcRun := 'CALC';
	//----------------------------------------
	//----------------------------------------
	//----------------------------------------
end;

