function FindsByAttribIconFile(sAttrib,sYesNo:string):string;
begin
  //puvodne byly ikony jen *.gif, nove je predelali do *.png
  //nove attributy jsou uz jen v *.png
  //ale snakes-yes/no uz neexistuje, ten je jen v *.gif
  //navic tam, kde tento attribut je, jej pro zobrazeni v listingu GS nahrazuje
  //attributem dangerousanimals, takze v listingu ta ikonka vubec neni
  //png obrazky jsou ve velikosti 80x80, takze pres CSS menime jejich velikost
  Result:=sAttrib;
  //pokud je jmeno attributu bez yes/no, musi byt toto zadano samostatne
  if(sYesNo<>'') then Result:=Result+'-'+sYesNo;
  if(sAttrib='snakes-yes') or (sAttrib='snakes-no') or (sAttrib='snakes') then Result:=sAttrib+'.gif'
  else Result:=Result+'.png';
end;

function FindsByAttribSequence(sSort,sFilter:string):string;
var tab: TSqliteTable;
    sSql:string;
    sDivStart,sDivEnd:string;
begin
  Result:='';
  sDivStart:='<div class="cAttribDiv">';
  sDivEnd:='</div>';
  sSql:='SELECT gtv.value attr, count(gtv.value) pocet'
    +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE gt.id=gc.id AND gc.dtfound>0 AND '+sCachePrefixForSql
    +'   AND gtc.key=gt.ptrkat AND gtc.value=''attribute'' and gtv.key=gt.ptrvalue'
    +sFilter
    +' GROUP BY gtv.value';
  if(sSort='Name') then sSql:=sSql+' ORDER BY gtv.value'  
  else  sSql:=sSql+' ORDER BY count(gtv.value) desc';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    while (not tab.eof) do begin
      Result:=Result+sDivStart
        +'<img class="cAttribIcon" src="https://www.geocaching.com/images/attributes/'
        +FindsByAttribIconFile(tab.FieldByName['attr'],'')+'" title="'+tab.FieldByName['attr']
        +': '+tab.FieldByName['pocet']+'" /><br />'+tab.FieldByName['pocet']+sDivEnd;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
end;

function FindsByAttribYesNo(sSort,sFilter:string):string;
var tab: TSqliteTable;
    sYes,sNo,sOther,s,sSql:string;
    sDivStart,sDivEnd:string;
begin
  Result:='';
  sDivStart:='<div class="cAttribDiv">';
  sDivEnd:='</div>';
  sSql:='SELECT gtv.value attr, count(gtv.value) pocet'
    +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE gt.id=gc.id AND gc.dtfound>0 AND '+sCachePrefixForSql
    +'   AND gtc.key=gt.ptrkat AND gtc.value=''attribute'' and gtv.key=gt.ptrvalue'
    +sFilter
    +' GROUP BY gtv.value';
  if(sSort='Name') then sSql:=sSql+' ORDER BY gtv.value'
  else  sSql:=sSql+' ORDER BY count(gtv.value) desc';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    while (not tab.eof) do begin
      s:=sDivStart+'<img class="cAttribIcon" src="https://www.geocaching.com/images/attributes/'
        +FindsByAttribIconFile(tab.FieldByName['attr'],'')+'" title="'+tab.FieldByName['attr']
        +': '+tab.FieldByName['pocet']+'" /><br />'+tab.FieldByName['pocet']+sDivEnd;
      sSql:=tab.FieldByName['attr'];
      if(Pos('-yes',sSql)>0) then sYes:=sYes+s
      else if(Pos('-no',sSql)>0) then sNo:=sNo+s
      else sOther:=sOther+s;
      tab.Next();
    end;
    Result:=Result+'<p class="cAttribPara">'+_('Positive attributes')+'</p>'+sYes
      +'<p class="cAttribPara">'+_('Negative attributes')+'</p>'+sNo;
    if(sOther<>'') then Result:=Result+'<p class="cAttribPara">'+_('Other attributes')+'</p>'+sOther;
  finally
    tab.Free();
  end;
end;

function FindsByAttribTable(sSort,sFilter:string):string;
var tab: TSqliteTable;
    sYes,sNo,sIcon,sOther,s,sSql:string;
    sTdLeft,sTdRight:string;
    aAttr,aName:TStringList;
    i,j,iWidthLeft,iMax:integer;
begin
  Result:=CRLF+'<table class="cAttribTable" style="%StyleAttribTable%">';
  //vypocteme sirky krajnich sloupcu a nastavime je do stylu
  iWidthLeft:=(iWidth-48)/2; //42=sirka prostredniho sloupce s ikonama atributu
  sTdLeft:=ReplaceString(GlobalVarGet('StyleAttribTableTdLeft',false),'%Width%',IntToStr(iWidthLeft));
  sTdRight:=ReplaceString(GlobalVarGet('StyleAttribTableTdRight',false),'%Width%',IntToStr(iWidthLeft));
  aName:=TStringList.Create();
  aAttr:=TStringList.Create();
  try
    sSql:='SELECT gtv.value attr, count(gtv.value) pocet'
      +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
      +' WHERE gt.id=gc.id AND gc.dtfound>0 AND '+sCachePrefixForSql
      +'   AND gtc.key=gt.ptrkat AND gtc.value=''attribute'' and gtv.key=gt.ptrvalue'
      +sFilter
      +' GROUP BY gtv.value';
    if(sSort='Name') then sSql:=sSql+' ORDER BY gtv.value'  
    else  sSql:=sSql+' ORDER BY count(gtv.value) desc';
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      //vypocteme maximalni pocet atributu, abychom mohli vytvorit histogram
      while (not tab.eof) do begin
        aAttr.Add(tab.FieldByName['attr']+'='+tab.FieldByName['pocet']);
        s:=tab.FieldByName['attr'];
        sOther:=Fetch(s,'-no');
        s:=Fetch(sOther,'-yes');
        if(aName.IndexOf(s)<0) then aName.Add(s); //pridame jmeno atributu bez ohledu na yes/no
        i:=StrToInt(tab.FieldByName['pocet']);
        if(iMax<i) then iMax:=i;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    //vytvorime radky tabulky
    for i:=0 to aName.Count-1 do begin
      sIcon:='<img class="cAttribTableIcon" title="'+aName[i]+'-yes: '+aAttr.Values[aName[i]+'-yes']+'" '
        +'src="https://www.geocaching.com/images/attributes/'+FindsByAttribIconFile(aName[i],'yes')+'" />'
        +'<img class="cAttribTableIcon" title="'+aName[i]+'-no: '+aAttr.Values[aName[i]+'-no']+'" '
        +'src="https://www.geocaching.com/images/attributes/'+FindsByAttribIconFile(aName[i],'no')+'" />'
        ;
      s:=aAttr.Values[aName[i]+'-yes'];
      if(s='') then j:=0 else j:=StrToInt(s);
      if(iMax=0) then j:=0
      else j:=Trunc(0.9+iWidthLeft*j/iMax);
      sYes:='<div class="cAttribTableTdDiv" style="width:'+IntToStr(iWidthLeft)+'px;">'
        +'<div class="cAttribTableTextLeft">'+s+'</div>'
        +'<div class="cAttribTableHistogramLeft" style="width:'+IntToStr(j)+'px;">&nbsp;</div>'
        +'</div>';
      s:=aAttr.Values[aName[i]+'-no'];
      if(s='') then j:=0 else j:=StrToInt(s);
      if(iMax=0) then j:=0
      else j:=Trunc(0.9+iWidthLeft*j/iMax);
      sNo:='<div class="cAttribTableTdDiv" style="width:'+IntToStr(iWidthLeft)+'px;">'
        +'<div class="cAttribTableTextRight">'+s+'</div>'
        +'<div class="cAttribTableHistogramRight" style="width:'+IntToStr(j)+'px;">&nbsp;</div>'
        +'</div>';
      Result:=Result+'<tr class="cAttribTableTr">'+CRLF
        +'  <td class="cAttribTableTdLeft" style="'+sTdLeft+'">'+sYes+'</td>'+CRLF
        +'  <td class="cAttribTableTdMiddle">'+sIcon+'</td>'+CRLF
        +'  <td class="cAttribTableTdRight" style="'+sTdRight+'">'+sNo+'</td>'+CRLF
        +'</tr>'+CRLF;
    end;
  finally
    aAttr.Free();
  end;
  aName.Free();
  Result:=Result+'</table>'+CRLF;
end;

//hlavni funkce modulu
function FindsByAttrib_Run(aPar:TStringList):string;
var s,sSort:string;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Result:=Result+'<div class="cAttribsDiv">';
  s:=aPar.Values['SortBy'];
  sSort:=Fetch(s,'-');
  s:=aPar.Values['OutputType'];
  case Fetch(s,'-') of
  'Sequence': Result:=Result+FindsByAttribSequence(sSort,SetSqlFilter(aPar));
  'Yes/No':   Result:=Result+FindsByAttribYesNo(sSort,SetSqlFilter(aPar));
  'Table':    Result:=Result+FindsByAttribTable(sSort,SetSqlFilter(aPar));
  else Log(_('ERR: unknown type of output.'));
  end;
  Result:=Result+'</div>'+CRLF;
end;