type Finds_Level=array[0..1000] of string;
type DataTypes=array[0..100] of string;

//hlavni funkce modulu
function FindsTreeMap_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    i,j,k,iCount,iSum,iType,iBar,iComma,iColor,iColorType:integer;
    s,sSql,sSize,sEId:string;
	sType,sTypeNew,sElements,sHeader,sParamType,sSwap,sCustomSQL,sActualDB:String;
	sTempDB,sNewDB,sDBName,sChartType,sBarProduct:String;
    aLevel1:Finds_Level;
	aLevel2:Finds_Level;
	aValue:Finds_Level;
	aType,aBar,aRes:DataTypes;
	OtherDB: TSqliteDatabase;
    bOtherDB,bEndLoop:Boolean;
	colorPalette,colorPalette0,colorPalette1,colorPalette2,colorPalette3,colorPalette4,colorPalette5,colorPalette6,colorPalette7:array of String;
begin
  Result:='';
  sHeader:='';
  colorPalette0:=['15','#c1232b','#27727b','#fcce10','#e87c25','#b5c334','#fe8463','#9bca63','#fad860','#60c0dd','#f3a43b','#d7504b','#f4e001','#c6e579','#f0805a','#26c0c0'];
  colorPalette1:=['6','#516b91','#59c4e6','#edafda','#93b7e3','#a5e7f0','#cbb0e3'];
  colorPalette2:=['21','#2ec7c9','#b6a2de','#5ab1ef','#e87c25','#ffb980','#d87a80','#8d98b3','#e5cf0d','#97b552','#95706d','#dc69aa','#07a2a4','#9a7fd1','#588dd5','#f5994e','#c05050','#59678c','#c9ab00','#7eb00a','#6f5553','#c14089'];
  colorPalette3:=['11','#4f6980','#849db1','#a2ceaa','#638b66','#bfbb60','#f47942','#fbb04e','#b66353','#d7ce9f','#b9aa97','#7e756d'];
  colorPalette4:=['20','#e01f54','#001852','#f5e8c8','#b8d2c7','#c6b38e','#a4d8c2','#f3d999','#d3758f','#dcc392','#2e4783','#82b6e9','#ff6347','#a092f1','#0a915d','#eaf889','#6699ff','#ff6666','#3cb371','#d5b158','#38b6b6'];
  colorPalette5:=['6','#3fb1e3','#6be6c1','#626c91','#a0a7e6','#c4ebad','#96dee8'];
  colorPalette6:=['20','#e6194b','#3cb44b','#ffe119','#4363d8','#f58231','#911eb4','#46f0f0','#f032e6','#bcf60c','#fabebe','#008080','#e6beff','#9a6324','#fffac8','#800000','#aaffc3','#808000','#ffd8b1','#000075','#808080'];
  colorPalette7:=['10','#1170aa','#fc7d0b','#a3acb9','#57606c','#5fa2ce','#c85200','#7b848f','#a3cce9','#ffbc79','#c8d0d9'];
  //
  s:=aPar.Values['ColorTheme'];
  iColorType:=StrToInt(Trim(Fetch(s,'-')));
  Case iColorType of
    1 : colorPalette := colorPalette0;
    2 : colorPalette := colorPalette1;
	3 : colorPalette := colorPalette2;
	4 : colorPalette := colorPalette3;
	5 : colorPalette := colorPalette4;
	6 : colorPalette := colorPalette5;
	7 : colorPalette := colorPalette6;
	8 : colorPalette := colorPalette7;
	else colorPalette := colorPalette0;
  end;
  //
  s:=aPar.Values['Type'];
  sParamType:=Trim(Fetch(s,'-'));
  sSwap:=aPar.Values['SwapParameters'];
  sCustomSQL:=aPar.Values['CustomSQL'];
  s:=aPar.Values['ChartType'];
  sChartType:=Trim(Fetch(s,'-'));
  //
  if (sCustomSQL='No') then
  begin
	  if (sParamType='TypeAndYear') then
	  begin  
		sSql:='WITH treemapdata(level1,level2,cnt)';
		sSql:=sSql+' AS (SELECT gc.cachetype level1, substr(gc.dtfound,1,4) level2, count(gc.id) cnt';
		sSql:=sSql+' FROM geocache gc';
		sSql:=sSql+' WHERE gc.dtfound > 0'+SetSqlFilter(aPar);
		sSql:=sSql+' group by gc.cachetype, substr(gc.dtfound,1,4))';
	  end
	  else if (sParamType='CountryAndYear') then begin
		sSql:='WITH treemapdata(level1,level2,cnt)';
		sSql:=sSql+' AS (SELECT gc.country level1, substr(gc.dtfound,1,4) level2, count(gc.id) cnt';
		sSql:=sSql+' FROM geocache gc';
		sSql:=sSql+' WHERE gc.dtfound > 0'+SetSqlFilter(aPar);
		sSql:=sSql+' group by gc.country, substr(gc.dtfound,1,4))';
	  end
	  else if (sParamType='CountryAndType') then begin
		sSql:='WITH treemapdata(level1,level2,cnt)';
		sSql:=sSql+' AS (SELECT gc.country level1, gc.cachetype level2, count(gc.id) cnt';
		sSql:=sSql+' FROM geocache gc';
		sSql:=sSql+' WHERE gc.dtfound > 0'+SetSqlFilter(aPar);
		sSql:=sSql+' group by gc.country, gc.cachetype)';
	  end
	  else if (sParamType='TerrainDifficulty') then begin
		sSql:='WITH treemapdata(level1,level2,cnt)';
		sSql:=sSql+' AS (SELECT ''T:''||gc.terrain level1, ''D:''||gc.difficulty level2, count(gc.id) cnt';
		sSql:=sSql+' FROM geocache gc';
		sSql:=sSql+' WHERE gc.dtfound > 0 and gc.cachetype <> ''Lab Cache'''+SetSqlFilter(aPar);
		sSql:=sSql+' group by ''T:''||gc.terrain, ''D:''||gc.difficulty)';
	  end
	  else if (sParamType='FTxInYear') then begin
		sSql:='WITH treemapdata(level1,level2,cnt)';
		sSql:=sSql+' AS (SELECT gtv.value level1, substr(gc.dtfound,1,4) level2, count(gc.id) cnt';
		sSql:=sSql+' FROM geocache gc';
		sSql:=sSql+' INNER JOIN geotag gt ON (gc.id = gt.id)';
		sSql:=sSql+' INNER JOIN geotagcategory gtc ON (gt.ptrkat = gtc.key AND gtc.value = ''FTF'')';
		sSql:=sSql+' INNER JOIN geotagvalue gtv ON(gt.ptrvalue = gtv.key)';
		sSql:=sSql+' WHERE gc.dtfound > 0';
		sSql:=sSql+' group by gtv.value, substr(gc.dtfound,1,4))';
	  end
	  else begin
		sSql:='WITH treemapdata(level1,level2,cnt)';
		sSql:=sSql+' AS (SELECT ''D:''||gc.difficulty||''/''||''T:''||gc.terrain level1, ''D/T'' level2, count(gc.id) cnt';
		sSql:=sSql+' FROM geocache gc';
		sSql:=sSql+' WHERE gc.dtfound > 0  and gc.cachetype <> ''Lab Cache'''+SetSqlFilter(aPar);
		sSql:=sSql+' group by ''D:''||gc.difficulty||''/''||''T:''||gc.terrain)';
	  end
  end
  else begin
	s:=ReplaceString(aPar.Values['SQL'],'%CRLF%',CRLF);
	sSql:=GlobalVarReplace(ReplaceString(s,'%CRLF%',CRLF));
	if (sSql='') then
	begin
		Log('SQL - neexistuje SQL!');
		Result:='';
		exit;
	end;
	if (Pos('treemapdata',sSql)=0) then
	begin
		Log('SQL - neobsahuje sekci treemapdata!');
		Log('SQL mus mt tvar: WITH treemapdata(level1,level2,cnt) AS (njak select generujc sloupce level1, level2, a cnt = poet za group level1 a level2)');
		Result:='';
		exit;
	end;
  end;  
  //
  if(sSwap='No') then
  begin
	sSql:=sSql+' SELECT t.level1, t.level2, t.cnt';  
	sSql:=sSql+' FROM treemapdata t';
	sSql:=sSql+' ORDER BY t.level1, t.level2';
  end
  else begin
	sSql:=sSql+' SELECT t.level1 as level2, t.level2 as level1, t.cnt';  
	sSql:=sSql+' FROM treemapdata t';
	sSql:=sSql+' ORDER BY t.level2, t.level1';	
  end;
  //SQL
  Log('SQL: '+ sSQL);
  if (sCustomSQL='No') then
  begin
	tab:=Geoget_DB.GetTable(sSql,false);
  end
  else begin
	if (Trim(aPar.Values['DBName'])='') then
	begin
	    tab:=Geoget_DB.GetTable(sSql,false);
	end
	else begin
		bOtherDB := true;
		sDBName	:= aPar.Values['DBName'];
		if not (FileExists(GEOGET_DATADIR + '\' + sDBName)) then begin
			Log('There is no database :'+sDBName+' graph not be created!');
			bOtherDB:=false;
		end;
		//jestli existuje prepne ji a provede SQL
		if bOtherDB then
		begin      
		  sActualDB := GEOGET_DBNAME;
		  sTempDB := sDBName;
		  sNewDB := Fetch(sTempDB,'.');
		  if not ((sActualDB = sNewDB) or (sTempDB = '')) then begin
			Log('Other DB: ' + GEOGET_DATADIR + '\' + sNewDB + '.db3');
			OtherDB := TSqliteDatabase.Create(GEOGET_DATADIR + '\' + sNewDB + '.db3');
			tab := OtherDB.GetTable((sSql), false);        
		  end;          
		end;
	end;
  end;
  if(tab<>nil) then begin
	if (sChartType = 'Treemap') or (sChartType = 'Sunburst') then begin
	  i:=-1;sType:='';
	  //seskld jednotliv typy ke a roky
	  try
		while not tab.eof do begin
		  sTypeNew:=UtfToAnsi(tab.FieldByName['level1']);
		  if (sType <> sTypeNew) then
		  begin
			if i>=0 then aLevel1[i]:=Replacestring(aLevel1[i],'%Sum%',IntToStr(iSum));		
			Inc(i);
			iSum:=0;
			aLevel2[i]:='';
			sType:=sTypeNew;
			aLevel1[i]:='name: '''+sType+''','+CRLF
			+'value: %Sum%,'+CRLF			
			+'children: [';
		  end;
		  //
		  iCount:=StrToInt(tab.FieldByName['cnt']);
		  iSum:=iSum+iCount;
		  //
		  aLevel2[i]:=aLevel2[i]+'{'+CRLF
		  +'  name: '''+UtfToAnsi(tab.FieldByName['level2'])+''','+CRLF
		  +'  value: '+IntToStr(iCount)+CRLF
		  +'},'+CRLF;
		  //
		  tab.Next();
		end;
		aLevel1[i]:=Replacestring(aLevel1[i],'%Sum%',IntToStr(iSum));
		iType:=i;	
	  finally
		tab.Free();
	  end;
	  
	  //seskld jednotliv sekce dle potu typu ke
	  iComma:=Length(','+CRLF);
	  sElements:='name: '''+_('Total finds')+''','+CRLF;
	  //
	  if (sChartType = 'Treemap') then
		sElements:=sElements+'type: ''treemap'','+CRLF
	  else
		sElements:=sElements+'type: ''sunburst'','+CRLF;
	  //
	  sElements:=sElements+'label: {'+CRLF
	  +' show: true,'+CRLF
	  +' formatter: ''{b}'''+CRLF
	  +'},'+CRLF
	  +'upperLabel: {'+CRLF
	  +' show: true,'+CRLF
	  +' height: 21,'+CRLF
	  +' color: ''#fff'''+CRLF
	  +'},'+CRLF
	  +'data: ['+CRLF;
	  For i:=0 to iType do
	  begin
		sElements:=sElements+'{'+CRLF
		+aLevel1[i]+CRLF
		+Copy(aLevel2[i],1,Length(aLevel2[i])-iComma)+CRLF
		+']'+CRLF
		+'},'+CRLF;	
	  end;
	  sElements:=Copy(sElements,1,Length(sElements)-iComma)+CRLF
	  +'],'+CRLF;
	  
	  //Title
	  if(aPar.Values['HeaderToGraph']='No') then
	  begin
		//{$ifdef DEBUG_HELPER} LDH('Treemap header NO');{$endif}
		if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar)
	  end
	  else begin
		//{$ifdef DEBUG_HELPER} LDH('Treemap header YES');{$endif}
		if(aPar.Values['Title']<>'') then
		begin
		  //{$ifdef DEBUG_HELPER} LDH('Treemap header TEXT');{$endif} 	
		  sHeader:='title: {'+CRLF
		  +' left: ''center'','+CRLF
		  +' text: '''+aPar.Values['Title']+''','+CRLF
		  +' subtext: '''+aPar.Values['Subtext']+''''+CRLF
		  +'},'+CRLF;
		end;
	  end;
	  //graf
	  sEId:='ID'+IntToStr(iItem);
	  Result:=Result+'<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr(iWidth)+'px;"></div>'+CRLF
		+'<script type="text/javascript">'+CRLF
		+'  var chart_'+sEId+'=echarts.init(document.getElementById('''+sEId+'''));'+CRLF
		+'  option={'+CRLF
		+sHeader
		+'    tooltip: {formatter: function (info) {'+CRLF
		+'      var value = info.value;'+CRLF
		+'      var treePathInfo = info.treePathInfo;'+CRLF
		+'      var treePath = [];'+CRLF
		+'      for (var i = 1; i < treePathInfo.length; i++) {'+CRLF
		+'        treePath.push(treePathInfo[i].name);'+CRLF
		+'      }'+CRLF
		+'      return ['+CRLF
		+'        ''<div class="tooltip-title">'' +'+CRLF
		+'          echarts.format.encodeHTML(treePath.join(''/'')) +'+CRLF
		+'          ''</div>'','+CRLF
		+'        '''+_('Found')+': '' + echarts.format.addCommas(value)'+CRLF
		+'      ].join('''');'+CRLF
		+'    }},'+CRLF
		+'    series: ['+CRLF
		+'      {'+CRLF
		+sElements
		+'	  levels: ['+CRLF
		+'    {'+CRLF
		+'		itemStyle: {'+CRLF
		+'			borderColor: ''#555'','+CRLF
		+'          borderWidth: 2,'+CRLF
		+'          gapWidth: 3,'+CRLF
		+'        }'+CRLF
		+'      },'+CRLF
		+'      {'+CRLF
		+'        colorSaturation: [0.3, 0.6],'+CRLF
		+'        itemStyle: {'+CRLF
		+'          borderColorSaturation: 0.7,'+CRLF
		+'          gapWidth: 2,'+CRLF
		+'          borderWidth: 2'+CRLF
		+'        }'+CRLF
		+'      },'+CRLF
		+'      {'+CRLF
		+'        colorSaturation: [0.3, 0.5],'+CRLF
		+'        itemStyle: {'+CRLF
		+'          borderColorSaturation: 0.6,'+CRLF
		+'          gapWidth: 1'+CRLF
		+'       }'+CRLF
		+'      },'+CRLF
		+'      {'+CRLF
		+'        colorSaturation: [0.3, 0.5]'+CRLF
		+'      }'+CRLF
		+'    ]'+CRLF
		+'      }'+CRLF
		+'    ]'+CRLF
		+'  };'+CRLF    
		+'  chart_'+sEId+'.setOption(option);'+CRLF
		+'</script>'+CRLF+CRLF;
	  {$ifdef DEBUG_HELPER} LDH('ECHART: '+Result);{$endif} 	
	  Output(Result);
	  Result:='';
	end
	else if (sChartType = 'MultiBar') then begin
	  try
		iComma:=Length(',');
		iCount:=-1;sBarProduct:='';
		//
		while not tab.eof do begin
		  Inc(iCount);
		  aLevel1[iCount]:=UtfToAnsi(tab.FieldByName['level1']);
		  aLevel2[iCount]:=UtfToAnsi(tab.FieldByName['level2']);
		  aValue[iCount]:=tab.FieldByName['cnt'];
		  //		  
		  tab.Next();
		end;
		//poet sloupc v srii
		sType:=''; iType:=-1; 
		For i:=0 to iCount do
		begin
			if sType <> aLevel1[i] then begin
				Inc(iType);
				sType:=aLevel1[i];
				sBarProduct:=sBarProduct+''''+sType+''',';
				aType[iType]:=sType;
			end;
		end;
		sBarProduct:=Copy(sBarProduct,1,Length(sBarProduct)-iComma);
		//existujc srie
		sType:=''; iBar:=-1; 
		For i:=0 to iCount do
		begin
			bEndLoop := false;
			if sType <> aLevel2[i] then begin
				if iBar > 0 then begin
					For j:=0 to iBar do
					begin
						if aLevel2[i] = aBar[j] then 
						begin
							bEndLoop := true;
							Break;
						end;
					end;
					if bEndLoop then continue;
				end;
				Inc(iBar);
				sType:=aLevel2[i];				
				aBar[iBar]:=sType;
				aRes[iBar]:=''''+sType+''',';
				For j:=0 to iType do
				begin
				  aRes[iBar]:=aRes[iBar]+'%'+IntToStr(j)+'%,';	
				end;
				aRes[iBar]:=Copy(aRes[iBar],1,Length(aRes[iBar])-iComma);
			end;
		end;
		//sort poloek dle abecedy
		for i := 0 to iBar-1 do
			for j := 0 to iBar-i do
				if aBar[j] < aBar[j+1] then begin
					s := aBar[j];
					aBar[j] := aBar[j+1];
					aBar[j+1] := s;
					//
					s := aRes[j];
					aRes[j] := aRes[j+1];
					aRes[j+1] := s;
				end;
		//-------------------------
		sType:='';
		For i:=0 to iCount do
		begin
		  bEndLoop := false;	
		  For j:=0 to iBar do
		  begin
		    For k:=0 to iType do
			begin
			  if (aBar[j] = aLevel2[i]) and (aType[k] = aLevel1[i]) then
			  begin
				sType := aRes[j];
			    aRes[j] := Replacestring(aRes[j],'%'+IntToStr(k)+'%',aValue[i]);
				if aRes[j] <> sType then
				begin
					bEndLoop:=true;
					Break;				
				end;	
			  end;
			end;
			if bEndLoop then Break;
	      end;		  
		end;
		//nulov hodnoty a dataset
		iComma:=Length(','+CRLF);
		sElements:='dataset: {'+CRLF
		+'  source: ['+CRLF
		+'    [''x'','+sBarProduct+'],'+CRLF;
		//log(sBarProduct);
		For i:=iBar downto 0 do
		begin
		  For j:=0 to iType do
		  begin	
			aRes[i] := Replacestring(aRes[i],'%'+IntToStr(j)+'%','0');			
		  end;
		  sElements:=sElements+'    ['+aRes[i]+'],'+CRLF
		  //Log(aRes[i]);
		end;
		sElements:=Copy(sElements,1,Length(sElements)-iComma)+CRLF
		+'  ]'+CRLF
		+'},'+CRLF;
		//log(sElements);
		//
		if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
		//
		sEId:='ID'+IntToStr(iItem);
		Result:=Result+'<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr((iWidth*3)/5)+'px;"></div>'+CRLF
		+'<script type="text/javascript">'+CRLF
		+'  var chart_'+sEId+'=echarts.init(document.getElementById('''+sEId+'''));'+CRLF
		+'  option={'+CRLF
		+'  legend: {},'+CRLF
		+'  tooltip: {},'+CRLF
		+sElements
		+'  xAxis: { type: ''category''},'+CRLF
		+'  yAxis: {},'+CRLF
		+'  series:[';
		iColor:=StrToInt(colorPalette[0]); 
		for i:=0 to iType do
		  Result:=Result+'{ type: ''bar'', itemStyle: { color: '''+colorPalette[(i mod iColor)+1]+''' } }, ';
		Result := Copy(Result,1,Length(Result)-Length(', '))+']'+CRLF
		+'  };'+CRLF    
		+'  chart_'+sEId+'.setOption(option);'+CRLF
		+'</script>'+CRLF+CRLF;
		{$ifdef DEBUG_HELPER} LDH('ECHART: '+Result);{$endif}
		Output(Result);
		Result:='';		
		//		
	  finally
		tab.Free();
	  end;	  
	  Result:='';
	end
	else begin
	  try
		iComma:=Length(',');
		iCount:=-1;sBarProduct:='';
		//
		while not tab.eof do begin
		  Inc(iCount);
		  aLevel1[iCount]:=UtfToAnsi(tab.FieldByName['level1']);
		  aLevel2[iCount]:=UtfToAnsi(tab.FieldByName['level2']);
		  aValue[iCount]:=tab.FieldByName['cnt'];
		  //		  
		  tab.Next();
		end;
	  finally
		tab.Free();
	  end;
	  //
	  //poet sloupc v srii
	  sType:=''; iType:=-1; 
	  For i:=0 to iCount do
	  begin
		if sType <> aLevel1[i] then begin
		  Inc(iType);
		  sType:=aLevel1[i];
		  sBarProduct:=sBarProduct+''''+sType+''',';
		  aType[iType]:=sType;
		end;
	  end;
	  sBarProduct:=Copy(sBarProduct,1,Length(sBarProduct)-iComma);
	  {$ifdef DEBUG_HELPER} LDH('BAR: '+sBarProduct);{$endif}
	  //
	  sType:=''; iBar:=-1; 
	  For i:=0 to iCount do
	  begin
	    bEndLoop := false;
		if sType <> aLevel2[i] then begin
		  if iBar > 0 then begin
			For j:=0 to iBar do
			begin
			  if aLevel2[i] = aBar[j] then 
			  begin
				bEndLoop := true;
				Break;
			  end;
			end;
			if bEndLoop then continue;
		  end;
		  Inc(iBar);
		  sType:=aLevel2[i];				
		  aBar[iBar]:=sType;
		  aRes[iBar]:='';
		  For j:=0 to iType do
		  begin
			aRes[iBar]:=aRes[iBar]+'%'+IntToStr(j)+'%,';	
		  end;
		  aRes[iBar]:=Copy(aRes[iBar],1,Length(aRes[iBar])-iComma);
		end;
	  end;
	  //sort poloek dle abecedy
	  for i := 0 to iBar-1 do
	    for j := 0 to iBar-i do
		  if aBar[j] < aBar[j+1] then
		  begin
			s := aBar[j];
			aBar[j] := aBar[j+1];
			aBar[j+1] := s;
			//
			s := aRes[j];
			aRes[j] := aRes[j+1];
			aRes[j+1] := s;
		  end;
	  //
	  sType:='';
	  For i:=0 to iCount do
	  begin
		bEndLoop := false;	
		For j:=0 to iBar do
		begin
		  For k:=0 to iType do
		  begin
			if (aBar[j] = aLevel2[i]) and (aType[k] = aLevel1[i]) then
			begin
			  sType := aRes[j];
			  aRes[j] := Replacestring(aRes[j],'%'+IntToStr(k)+'%',aValue[i]);
			  if aRes[j] <> sType then
			  begin
				bEndLoop:=true;
				Break;				
			  end;	
			end;
		  end;
		  if bEndLoop then Break;
	    end;		  
	  end;	
	  //-------------------------
	  //nulov hodnoty a dataset
	  iComma:=Length(','+CRLF);
	  sElements:='series: ['+CRLF;
	  iColor:=StrToInt(colorPalette[0]); 
	  For i:=iBar downto 0 do
	  begin
		For j:=0 to iType do
		begin	
		  aRes[i] := Replacestring(aRes[i],'%'+IntToStr(j)+'%','''-''');			
		end;
		sElements:=sElements+'  {'+CRLF
		+'    name: '''+aBar[i]+''','+CRLF
		+'    type: ''bar'','+CRLF
		+'    stack: ''total'','+CRLF
		//+'    label: {'+CRLF
		//+'      show: true'+CRLF
		//+'    },'+CRLF
		+'    itemStyle: {'+CRLF
        +'      color: '''+colorPalette[((iBar-i) mod iColor)+1]+''''+CRLF
        +'    },'+crlf
		+'    emphasis: {'+CRLF
		+'      focus: ''series'''+CRLF
		+'    },'+CRLF
		+'    data: ['+aRes[i]+']'+CRLF
		+'  },'+CRLF;		
	  end;
	  sElements:=Copy(sElements,1,Length(sElements)-iComma)
	  +']';
	  {$ifdef DEBUG_HELPER} LDH('EPART: '+sElements);{$endif}
	  //Chart
	  //
	  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
	  //
	  sEId:='ID'+IntToStr(iItem);
	  if (sChartType = 'StackedVBar') then
		Result:=Result+'<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr((iWidth*3)/5)+'px;"></div>'+CRLF
	  else
		Result:=Result+'<div id="'+sEId+'" style="width:'+IntToStr(iWidth)+'px; height:'+IntToStr((iWidth*4)/5)+'px;"></div>'+CRLF;
	  //	
	  Result:=Result+'<script type="text/javascript">'+CRLF
	  +'  var chart_'+sEId+'=echarts.init(document.getElementById('''+sEId+'''));'+CRLF
	  +'  option={'+CRLF
	  +'    tooltip: {'+CRLF
	  +'      trigger: ''axis'','+CRLF
	  +'      axisPointer: {'+CRLF
	  +'        type: ''shadow'''+CRLF
	  +'      },'+CRLF
	  +'      formatter: function (params) {'+CRLF
      +'        var output = params[0].axisValueLabel + ''<br/>'';'+CRLF
      +'        output += ''<table style="color:silver";>'';'+CRLF;
	  //
	  if (sChartType = 'StackedVBar') then
		Result:=Result+'        params.reverse().forEach(function (param) {'+CRLF
	  else
		Result:=Result+'        params.forEach(function (param) {'+CRLF; 
	  //	
      Result:=Result+'          if (param.value !== ''-'') {'+CRLF
      +'            output += `<tr>'+CRLF
      +'              <td>${param.marker}</td>'+CRLF
      +'              <td>${param.seriesName}</td>'+CRLF
	  +'			  <td>&nbsp;</td>'+CRLF
      +'              <td class="text-right font-bold tabular-nums">${param.value}</td>'+CRLF
      +'            </tr>`;'+CRLF
      +'          }'+CRLF
      +'        });'+CRLF
      +'        return output + ''</table>'';'+CRLF
      +'      }'+CRLF
	  +'    },'+CRLF
	  +'    legend: {},'+CRLF
	  +'    grid: {'+CRLF
	  +'      left: ''3%'','+CRLF
	  +'      right: ''4%'','+CRLF
	  +'      bottom: ''3%'','+CRLF
	  +'      containLabel: true'+CRLF
	  +'    },'+CRLF;
	  if (sChartType = 'StackedVBar') then
	  begin
		Result:=Result+'    xAxis: {'+CRLF
		+'      type: ''category'','+CRLF
		+'      data: ['+sBarProduct+']'+CRLF
		+'    },'+CRLF
		+'    yAxis: {'+CRLF
		+'      type: ''value'''+CRLF
		+'    },'+CRLF;
	  end
	  else begin
		Result:=Result+'    yAxis: {'+CRLF
		+'      type: ''category'','+CRLF
		+'      data: ['+sBarProduct+']'+CRLF
		+'    },'+CRLF
		+'    xAxis: {'+CRLF
		+'      type: ''value'''+CRLF
		+'    },'+CRLF;
	  end;
	  Result:=Result+sElements+CRLF
	  +'  };'+CRLF
	  +'  chart_'+sEId+'.setOption(option);'+CRLF
	  +'</script>'+CRLF+CRLF;
	  {$ifdef DEBUG_HELPER} LDH('ECHART: '+Result);{$endif}
	  Output(Result);
	  Result:='';
	end;
  end
  else Result:=Result+'--== No Data! ==--'+CRLF;
end;