function MapGenSvg_IsContinent(sMap:string):boolean;
//zjisti, zda mapa ma vybarvovaci staty nebo nejake statni uzemni celky (kraje, okresy, ...)
var ini:TMemIniFile;
    aSec:TStringList;
begin
  //nacteme seznam map rozdelenych do kontinentu, jen tyto mapy maji vybarvovaci staty
  Result:=false;
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenSvg.Maps.ini');
  try
    aSec:=TStringList.Create();
    try
      ini.ReadSectionValues('Kontinenty',aSec);
      if(aSec.IndexOf(sMap)>=0) then Result:=true;
    finally
      aSec.Free();
    end;
  finally
    ini.Free();
  end;
end;
{
function MapGenSvg_CountryToMap(sCountry:string):string;
//zjisti jmeno mapy, kterou je treba nakreslit pro zvoleny stat
var ini:TMemIniFile;
    s:string;
begin
  //nacteme seznam map statu s delenim do kraju
  Result:='';
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenSvg.Maps.ini');
  try
    s:=ini.ReadString('Kraje',sCountry,'');
    if(s='') then s:=ini.ReadString('Okresy',sCountry,'');
    if(s='') then s:=ini.ReadString('Mesta',sCountry,'');
    Result:=Fetch(s,'(');
  finally
    ini.Free();
  end;
end;
}
{
function MapGenSvg_TagForMap(sMap:string; bShowError:boolean; var sCategory,sValue,sCategoryNad,sValueNad:string):boolean;
//vraci hodnoty TagCategory a TagValue pro hledani kesi v prislusne oblasti pro zadanou mapu
var s:string;
    ini:TMemIniFile;
begin
  Result:=false; //nenasli jsme mapu
  sCategory:='';
  sValue:='';
  sCategoryNad:='';
  sValueNad:='';
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenSvg.Maps.ini');
  try
    s:=ini.ReadString('Map-tags',sMap,'?');
    if(s<>'?') then begin    //pokud najdeme, pouzijeme
      sCategory:=Fetch(s,';');
      sValue:=Fetch(s,';');
      sCategoryNad:=Fetch(s,';');
      sValueNad:=s;
      Result:=true;
    end;
  finally
    ini.Free();
  end;
end;
}

function MapGenSvg_Run(aPar:TStringList):string;
var s,sMap,sDivide,sTitle,sTable,sCols,sRegion,
      sTag,sTagVal,sTagNad,sTagValNad,
      sCht,sChd1,sChd2,sChld,sChf,sChldEmpty,
      sSql,sSqlPom,
      sSvg,sCountry,sServer
      :string;
    ix,n,iWidthMin,nTables:integer;
    nPrahaNalezene,nPrahaDostupne,
      //nBlavaNalezene,nBlavaDostupne,
      //nKosiceNalezene,nKosiceDostupne,
      nWienNalezene,nWienDostupne:integer;
    bPraha,bBlava,bKosice,bWien:boolean;
    tab:TSQLiteTable;
    aVal,aData:TStringList;
    ini:TMemIniFile;  //pro prevod jmena oblasti na zkratku
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  s:=aPar.Values['Map'];
  sMap:=Fetch(s,'-');
  sCountry:=sMap;
  s:=aPar.Values['RegionDivide'];      sDivide:=Fetch(s,'-');
  s:=aPar.Values['Data'];              sCht:=Fetch(s,'-');
  s:=aPar.Values['MapServer'];         sServer:=Fetch(s,'-');
  //s:=aPar.Values['ShowValues'];        sShowValues:=Fetch(s,'-');
  s:=aPar.Values['TablePosition'];     sTable:=Fetch(s,'-');
  iWidthMin:=StrToInt(aPar.Values['TableWidth']);
  nTables:=StrToInt(aPar.Values['TableSplitCount']);
  //s:=aPar.Values['ShowLabels'];        sShowLabels:=Fetch(s,'-');
  //s:=aPar.Values['RegionLabels'];      sRegionLabels:=Fetch(s,'-');
  //s:=aPar.Values['ValueSize'];         sValueSize:=Fetch(s,'-');
  //s:=aPar.Values['LabelSize'];         sLabelSize:=Fetch(s,'-');
  //s:=aPar.Values['HideNeighborhood'];
  if(UpperCase(s)<>'YES') then sChf:=''
  else sChf:='&chf=bg,s,%ColorMainBkg%';
  sTitle:=aPar.Values['Title'];
  //podle typu mapy zjistime tag
  sTag:='';
  sTagVal:='';
  sTagNad:='';    //nadrazeny tag pro identifikaci mestskych casti
  sTagValNad:=''; //hodnota nadrazeneho tagu pro identifikaci mestskych casti
  //rozhodneme o zpusobu zjistovani kesi v zadane mape (tagy, state nebo country)
  //pri automatickem rozhodovani preferujeme nase tagy pres state od gc.com
  if(MapGenSvg_IsContinent(sMap)) then sDivide:='Country'
  else begin
    sTag:=CalcRegionTagSupport_GetMapName(sMap); //zjistime, zda je zadany stat a najdeme pro nej mapu
    {$ifdef DEBUG_HELPER} LDH('Pro zadanou mapu (stat) hledam skutecnou mapu: '+sMap+'=>'+sTag); {$endif}
    if(sTag<>'') then sMap:=sTag;        //ve skutecnosti budeme vytvaret tuto mapu
    if(sDivide<>'geocaching.com') then CalcRegionTagSupport_TagForMap(sMap,false,sTag,sTagVal,sTagNad,sTagValNad)
    else sTag:='';
    {$ifdef DEBUG_HELPER} LDH('Pro mapu nalezen tag: '+sMap+'=>'+sTag); {$endif}
    if(sTag<>'') then begin //zkontrolujeme, zda existuje kategorie tagu, kterou mame pouzivat
      sSql:='SELECT count(key) FROM geotagcategory WHERE value="'+sTag+'"';
      if(Geoget_DB.GetTableValue(sSql)<1) then begin
        Log(_('ERR: unknown tagcategory')+' "'+sTag+' ('+sTitle+' '+_('map')+': '+sMap+')');
        sTag:=''; //misto tagu zkusime pouzit state
      end;
    end;
    //pokud tag neexistuje, budeme pracovat s polozkou State
    if(sDivide='Auto') then begin
      if(sTag='') then sDivide:='geocaching.com'
      else sDivide:='Divider';
    end;
    if(sTag='') and (sDivide<>'Country') then sDivide:='geocaching.com';
  end;
  {$ifdef DEBUG_HELPER} LDH('sCountry='+sCountry+', sMap='+sMap+', sDivide='+sDivide+', sTag='+sTag+', sTagVal='+sTagVal+', sTagNad='+sTagNad+', sTagValNad='+sTagValNad); {$endif}
  //otevreme ini soubor pro prevod jmena statu nebo oblasti na zkratku
  //zjistime, zda se jedna u mapu jednoho nebo vice statu (vybarvujeme staty nebo kraje?)
  aData:=TStringList.Create();
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenSvg.Abbrev.ini');
  try
    aVal:=TStringList.Create();
    try
      ini.ReadSectionValues(sMap,aVal);  //seznam vsech oblasti a zkratek pro tuto mapu
      if(aVal.Count>0) then begin
        sChldEmpty:=aVal[0];
        Fetch(sChldEmpty,'=');
      end;
    finally
      aVal.Free();
    end;
    //sestavime SQL pro zjistovani oblasti podle sDivide
    if(sDivide='Country') then begin //-----------------------------------------
      Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
      sCht:='Finds'; //pro kontinenty nikdy nedelame procenta
      sSql:='SELECT 0 Dostupne,count(gc.country) Nalezene,gc.country Jmeno,100 Procent'+CRLF
              +' FROM geocache gc'+CRLF
              +' WHERE gc.dtfound>0 AND '+sCachePrefixForSql+CRLF
              +' AND gc.id NOT IN ('+sIgnoreCaches+')'
              //+' AND gc.id NOT IN ('+IgnoreAndLocationless()+')'  //tohle zahrnuje i sIgnoreCaches
              +SetSqlFilter(aPar)
              +' group by gc.country'+CRLF //seskupime podle podle hodnoty tagu
              //+' order by gc.country'+CRLF
              +' order by Nalezene desc'+CRLF //vzdy podle poctu nalezu, protoze procenta u statu nejdou (nejsou data)
              ;
    end;
    if(sDivide='Divider') then begin //-----------------------------------------
      //zjistime hodnoty pro mapu
      if(sTagVal<>'') then begin
        Geoget_DB.AddParamText(':TagVal',sTagVal);
        sSqlPom:='   AND gtv.value like :TagVal';
      end;
      if(sTagNad<>'') and (sTagValNad<>'') then begin
        Geoget_DB.AddParamText(':TagCatNad',sTagNad);
        Geoget_DB.AddParamText(':TagValNad',sTagValNad);
        sSqlPom:='   AND gt.id IN ('+CRLF
                +'   SELECT gc.id'+CRLF
                +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
                +'     WHERE gc.id=gt.id'+CRLF
                +' AND gc.id NOT IN ('+sIgnoreCaches+')'
                //+' AND gc.id NOT IN ('+IgnoreAndLocationless()+')'  //tohle zahrnuje i sIgnoreCaches
                +'       AND gtc.key=gt.ptrkat and gtc.value=:TagCatNad and gtv.key=gt.ptrvalue'+CRLF
                +'       AND gtv.value LIKE :TagValNad'+CRLF
                +'   )'
                +CRLF;
      end;
      Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
      Geoget_DB.AddParamText(':TagCat',sTag);
      sSql:='SELECT A.pocet Dostupne,B.pocet Nalezene, A.Jmeno, 100*B.pocet/A.pocet Procent from'+CRLF
          // dostupne nebo nalezene kese s danym prefixem ('GC'/'OC'/'WM'/...) se
          // zadanou kategorii tagu
          +' (SELECT count(gtv.value) as pocet,gtv.value as Jmeno'+CRLF
            +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
            +' WHERE '+sCachePrefixForSql+SetSqlFilter(aPar)+CRLF
            +'   AND gt.id=gc.id'+CRLF
            +'   AND (gc.cachestatus<2 or gc.dtfound>0)'+CRLF
            +' AND gc.id NOT IN ('+sIgnoreCaches+')'
            //+' AND gc.id NOT IN ('+IgnoreAndLocationless()+')'  //tohle zahrnuje i sIgnoreCaches
            +'   AND gtc.key=gt.ptrkat and gtc.value=:TagCat and gtv.key=gt.ptrvalue'+CRLF
            + sSqlPom+CRLF      //pokud je treba, doplnime jeste hodnotu tagu
            +' group by gtv.value COLLATE NOCASE'+CRLF //seskupime podle podle hodnoty tagu
            +' order by gtv.value COLLATE NOCASE'+CRLF
          +') A'+CRLF
          +','+CRLF
          // pocet nalezenych kesi se zadanym prefixem ('GC'/'OC'/'WM'/...)
          // a se zadanou kategorii tagu
          +' (SELECT count(gtv.value) as pocet,gtv.value as Jmeno'+CRLF
            +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
            +' WHERE '+sCachePrefixForSql+SetSqlFilter(aPar)+CRLF
            +'   AND gt.id=gc.id'+CRLF
            +'   AND (gc.dtfound>0)'+CRLF
            +' AND gc.id NOT IN ('+sIgnoreCaches+')'
            //+' AND gc.id NOT IN ('+IgnoreAndLocationless()+')'  //tohle zahrnuje i sIgnoreCaches
            +'   AND gtc.key=gt.ptrkat and gtc.value=:TagCat and gtv.key=gt.ptrvalue'+CRLF
            + sSqlPom+CRLF      //pokud je treba, doplnime jeste hodnotu tagu
            +' group by gtv.value COLLATE NOCASE'+CRLF //seskupime podle podle hodnoty tagu
            +' order by gtv.value COLLATE NOCASE'+CRLF
          +') B'+CRLF
        +' where A.Jmeno=B.Jmeno'+CRLF;
      //doplnime zpusob razeni
      if(sCht='Perc') then sSql:=sSql+' order by Procent desc'+CRLF
      else sSql:=sSql+' order by Nalezene desc'+CRLF;
    end;
    if(sDivide='geocaching.com') then begin //----------------------------
      Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
      Geoget_DB.AddParamText(':country',sCountry);
      sSql:='SELECT A.pocet Dostupne,B.pocet Nalezene, A.Jmeno, 100*B.pocet/A.pocet Procent from'+CRLF
            // dostupne nebo nalezene kese s danym prefixem ('GC'/'OC'/'WM'/...) se
            // zadanou kategorii tagu
            +' (SELECT count(gc.state) as pocet,gc.state as Jmeno'+CRLF
              +' FROM geocache gc'+CRLF
              +' WHERE '+sCachePrefixForSql+SetSqlFilter(aPar)+CRLF
              +'   AND (gc.cachestatus<2 or gc.dtfound>0)'+CRLF
              +' AND gc.id NOT IN ('+sIgnoreCaches+')'
              //+' AND gc.id NOT IN ('+IgnoreAndLocationless()+')'  //tohle zahrnuje i sIgnoreCaches
              +'   AND gc.country=:country'+CRLF
              +' group by gc.state'+CRLF //seskupime podle podle hodnoty tagu
              +' order by gc.state'+CRLF
            +') A'+CRLF
            +','+CRLF
            // pocet nalezenych kesi se zadanym prefixem ('GC'/'OC'/'WM'/...)
            // a se zadanou kategorii tagu
            +' (SELECT count(gc.state) as pocet,gc.state as Jmeno'+CRLF
              +' FROM geocache gc'+CRLF
              +' WHERE '+sCachePrefixForSql+SetSqlFilter(aPar)+CRLF
              +'   AND (gc.dtfound>0)'+CRLF
              +' AND gc.id NOT IN ('+sIgnoreCaches+')'
              //+' AND gc.id NOT IN ('+IgnoreAndLocationless()+')'  //tohle zahrnuje i sIgnoreCaches
              +'   AND gc.country=:country'+CRLF
              +' group by gc.state'+CRLF //seskupime podle podle hodnoty tagu
              +' order by gc.state'+CRLF
            +') B'+CRLF
          +' where A.Jmeno=B.Jmeno'+CRLF;
      //doplnime zpusob razeni
      if(sCht='Perc') then sSql:=sSql+' order by Procent desc'+CRLF
      else sSql:=sSql+' order by Nalezene desc'+CRLF;
    end;
    //{$ifdef DEBUG_HELPER} LDH('sSQL='+sSql); {$endif}
    //Log('SQL='+sSql);
    nPrahaNalezene:=0; nPrahaDostupne:=0;
    //pokud maji byt pouzite hodnoty ze State, vytvorime jiny SQL

    tab:=Geoget_DB.GetTable(sSql,false);
    try
      ix:=0;
      while (not tab.eof) and (ix<1) do begin
        //Inc(ix);  //pro ladeni a hledani chybneho zaznamu
        //protoze ne vsechny znaky z jinych statu jdou prevest na ANSI, prevedeme je na ASCII
        sRegion:=tab.FieldAsString(2)
        s:=UtfToAscii(sRegion);
        if(s<>'') and (s<>'-') then begin //pokud tag existuje a ma smysluplnou hodnotu
          //pro okresy Praha 1 az Praha 10 pocitame soucet a pak vysledek jako
          //pro samostatnou Prahu
          bPraha:=false;   bBlava:=false;   bKosice:=false;    bWien:=false;
          if(sMap='CZokres') then begin
            //Log('HHHHH 1 s='+s+', Dostupne='+tab.FieldAsString(0)+', Nalezene='+tab.FieldAsString(1));
            if(RegexFind('(?i)^Praha [0-9]{1,2}$',s)) then begin
              nPrahaNalezene:=nPrahaNalezene+tab.FieldAsInteger(1);
              nPrahaDostupne:=nPrahaDostupne+tab.FieldAsInteger(0);
              //Log('HHHHH 2 s='+s+', Dostupne='+IntToStr(nPrahaDostupne)+', Nalezene='+IntToStr(nPrahaNalezene));
              bPraha:=true;
            end;
          end;
          if(sMap='ATokres') then begin
            //Log('HHHHH s='+s+', Dostupne='+tab.FieldAsString(0)+', Nalezene='+tab.FieldAsString(1));
            if(s='Wien-Umgebung-Gerasdorf') or (s='Wien-Umgebung-KlosterNeuburg') then begin
              nWienNalezene:=nWienNalezene+tab.FieldAsInteger(1);
              nWienDostupne:=nWienDostupne+tab.FieldAsInteger(0);
              bWien:=true;
            end;
          end;
          //prevedeme na zkratku vse ostatni nez okres Praha
          if(not bPraha) {and (not bBlava) and (not bKosice)} and (not bWien) then begin
            sTitle:=ini.ReadString(sMap,s,'??');
            if(sTitle='??') then begin
              sTitle:='tag:'+sTag;
              //if(sTagVal='') and (sTagValNad='') then sTitle:='tag:'+sTag
              //else begin
              //  if(sTag='') then sTitle:='tag1:'+sTag+' + tag2:'+sTagNad+'='+UtfToAnsi(sTagValNad)
              //  else sTitle:='tag:'+sTag+' like '+UtfToAnsi(sTagVal);
              //end;
              //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
              //AddError(_('ERR: unknown abbreviation for')+' "'+s+'" ('+sTitle+', '+_('map')+': '+sMap+')');
              Log(_('ERR: unknown abbreviation for')+' "'+s+'" ('+sTitle+', '+_('map')+': '+sMap+')');
            end
            else begin
              if(sChd1<>'') then begin
                sChd1:=sChd1+',';
                sChd2:=sChd2+',';
              end;
              sChd1:=sChd1+tab.FieldAsString(1);
              sChd2:=sChd2+tab.FieldAsString(3);
              sChld:=sChld+sTitle;
              aData.Add(sRegion);     //jmeno v UTF
              if(sCht='Finds') or (sCht='FindsPerc') then aData.Add(tab.FieldAsString(1));
              if(sCht='Perc') or (sCht='FindsPerc') then aData.Add(tab.FieldAsString(3));
              //{$ifdef DEBUG_HELPER} LDH('sChld='+sChld); {$endif}
            end;
          end;
          //Log('sMap='+sMap+', s='+s+' (zkratka '+ini.ReadString(sMap,s,'??')+'), Dostupne='+tab.FieldAsString(0)+', Nalezene='+tab.FieldAsString(1)+', Procent='+tab.FieldAsString(3));
          //Log('sChld='+sChld+', sChd1='+sChd1);
        end;
        tab.Next();
      end;
    finally
      if(tab<>nil) then tab.Free();
    end;
    //pokud je treba, doplnime soucty za celou Prahu
    if(sMap='CZokres') then begin
      if(sChd1<>'') and (nPrahaDostupne>0) then begin
        sChd1:=sChd1+',';
        sChd2:=sChd2+',';
      end;
      if(nPrahaDostupne>0) then begin
        sChd1:=sChd1+IntToStr(nPrahaNalezene);
        sChd2:=sChd2+IntToStr(100*nPrahaNalezene/nPrahaDostupne);
        sChld:=sChld+'AP'; //zkratka pro Hlavni mesto Praha
              aData.Add('Hlavn msto Praha');
              if(sCht='Finds') or (sCht='FindsPerc') then aData.Add(IntToStr(nPrahaNalezene));
              if(sCht='Perc') or (sCht='FindsPerc') then aData.Add(IntToStr(100*nPrahaNalezene/nPrahaDostupne));
      end;
      //Log('Po Praha: sChld='+sChld+', sChd1='+sChd1);
    end;
    {
    if(sMap='ATokres') then begin
      if(sChd1<>'') and (nWienDostupne>0) then begin
        sChd1:=sChd1+',';
        sChd2:=sChd2+',';
      end;
      if(nWienDostupne>0) then begin
        sChd1:=sChd1+IntToStr(nWienNalezene);
        sChd2:=sChd2+IntToStr(100*nWienNalezene/nWienDostupne);
        sChld:=sChld+'AP'; //zkratka pro Hlavni mesto Praha
      end;
    end;
    }
  finally
    if(ini<>nil) then ini.Free();
  end;
  //kontrola hodnot a pripadne varovani pri nesmyslech
  if(iWidth<300) then begin
    Log(_('WARN: The width of the map is less than the minimum will be adjusted to 300.'));
  end;
  if(sModuleError<>'') then Log(sModuleError);

  //{$ifdef DEBUG_HELPER} LDH('data:'+sChd1+':'); {$endif}
  if(sChd1='') and (sChd2='') then begin
    Log(_('ERR: no map data found')+' '+sCountry+' ('+sMap+')');
  end;
  s:=CONST_MAPGEN_SVG_URL_GCCZ;
  if(UpperCase(sServer)='DEBUG') then s:=CONST_MAPGEN_SVG_URL_DEBUG;
  s:=s+'mapgen.php?'
    +'cht=t,'+sCht
    +'&chs=wx'+IntToStr(iWidth)
    +'&chtm='+sMap
    +sChf
    +'&chco=%ColorMapRegionDNF%,%ColorMapMinBkg%,%ColorMapAvgBkg%,%ColorMapMaxBkg%';
  //barvy podle potreby, pokud sLabels obsahuje carku, predavame 2 barvy
  {
  if(sShowValues='Finds') then s:=s+',%ColorMapCountText%';
  if(sShowValues='Perc') then s:=s+',%ColorMapPercentText%';
  if(sShowValues='FindsPerc') then } s:=s+',%ColorMapCountText%,%ColorMapPercentText%';
  //if(sShowLabels<>'None') then s:=s+',%ColorMapAbbrevText%';
  //datove sady podle potreby
  if(sCht='Finds') then s:=s+'&chd='+sChd1;
  if(sCht='Perc') then s:=s+'&chd='+sChd2;
  //Log('OOOOO sCht='+sCht+CRLF+'OOOOO sChd1='+sChd1+CRLF+'OOOOO sChd2='+sChd2);
  if(sCht='FindsPerc') then s:=s+'&chd='+sChd1+'|'+sChd2;
  s:=GlobalVarReplace(s+'&chld='+sChld);
//{$ifdef DEBUG_HELPER} LDH('Volani generatoru: '+s); {$endif}
  Log('Volani generatoru: '+s);
  if(HttpAsk('GET',s,'','',sSvg)=false) then ShowMessage(_('ERR: error MapGen calling'))
  else begin
//{$ifdef DEBUG_HELPER} LDH('Nacteno: '+sSvg); {$endif}
    //odstranime <?xml ...>, ktere tam dava mapgen pro vkladani svg pres AJAX,
    //samostatne zobrazeni, ...
    sSvg:=RegexReplace('\<\?xml.*?>\s*',sSvg,'',false);
    //////doplnime do "filterXX" a #filterXX jedinecnou hodnotu o GlobalVarGet('IdElement');
    s:=GlobalVarGet('IdElement',true); //toto je hodnota nastavena v MapGenSvgSwitchCountries
    sSvg:=ReplaceString(sSvg,'"filter','"'+s+'filter');
    sSvg:=ReplaceString(sSvg,'#filter','#'+s+'filter');
    sSvg:=UtfToANSI(sSvg); //prevedeme na ANSI, aby se pak mohlo spravne preves do vystupniho kodovani
    ix:=iWidth;
    if(sTable='R') then begin
      if(nTables>0) then ix:=ix-(nTables*iWidthMin)
      else ix:=ix-iWidthMin;
    end;
    //pokud obsahuje <text ...>, doplnime ikonu pro prepinani popisku
    if(Pos('<text',sSvg)>1) then begin
      s:=CONST_MAPGEN_SVG_URL_GCCZ;
      if(UpperCase(sServer)='DEBUG') then s:=CONST_MAPGEN_SVG_URL_DEBUG;
      sSvg:='<div class="mapsSwitchRegionLabelsDiv">'
           +'<img class="mapsSwitchRegionLabels" onclick="switchMapRegionLabels();" '
           +'src="'+s+'Images/mapsSwitchRegionLabels.png" />'
           +'</div>'+CRLF+sSvg;
    end;
    Result:=Result+'<div id="svgMapa_'+aPar.Values['ID']+'" class="svgMap" style="width:'+IntToStr(ix)+'px;'
    if(sTable='R') then Result:=Result+'display:inline-block; vertical-align:top;';
    Result:=Result+'">'+CRLF+sSvg+'</div>'+CRLF;
  end;
  if(sTable<>'N') then begin
    if(sDivide='Country') then sCols:='Country flag' else sCols:=_('Region');
    if(sCht='Finds') or (sCht='FindsPerc') then sCols:=sCols+'|Count';
    if(sCht='Perc') or (sCht='FindsPerc') then sCols:=sCols+'|%=Right;';
    if(sTable='D') then begin
      //pokud je moc radku a mapa dost siroka, bylo by dobre tu udelat vice
      //tabulek vedle sebe
      //pocet datovych radku tabulky
      Result:=Result+OutputTableSplit(sCols,aData,iWidthMin,nTables);
    end
    else begin
      n:=iWidth;           //zapamatujeme si puvodni sirku
      iWidth:=iWidth-ix-5; //pro spravnou sirku tabulky
      Result:=Result//+'<div class="svgTable" style="width:'+IntToStr(ix)+'px;">'
        +OutputTableSplit(sCols,aData,iWidthMin,nTables)
        //+'</div>'+CRLF
        ;
      iWidth:=n; //vratime
    end;
  end;
  if(aData<>nil) then aData.Free();
  //pridame pouziti mapove knihovny a jquery, kterou mapova knihovna pouziva
  //protoze v Statrt.html je odkaz bez uvedeni typu scriptu, aby se predeslo
  //zdvojenemu vkladani knihovny, rovnez to tu musi byt bez typu
  //AddRowToHead('<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>');
  AddRowToHead('<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>');
end;