function MapGenSvgSwitchCountries_MapName(sMainModule:string;idxMap:integer):string;
begin
  Result:=sMainModule+'_Map'+IntToStr(idxMap);
end;

function MapGenSvgSwitchCountries_Run(aPar:TStringList):string;
var s,sDiv,sIdElemOld,sSql,sCountry,sOrder:string;
    i,j:integer;
    tab:TSqliteTable;
    aMapCountries,aMaps,aPom:TStringList;
    ini:TMemIniFile;
    fFce:TfceModuleRun; //spoustena funkce
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Output(ProcessCommand('CmdTitle',aPar));
  s:=aPar.Values['IncludeMaps'];
  s:=aPar.Values['SortBy'];
  sOrder:=Fetch(s,'-');
  if(sOrder='Finds') then sOrder:=sOrder+' DESC, Country';

  aMapCountries:=TStringList.Create();
  aMaps:=TStringList.Create();
  //zjistime seznam map, ktere umi MapGenFromState
  //Log('UUUUU 1 pocet statu modulu State: '+IntToStr(aMapsState.Count)+', '+ReplaceString(aMapsState.Text,CRLF,','));

  //zjistime seznam map, ktere umi MapGenSvg, nechame jen jmeno statu
  ini:=TMemIniFile.Create(GetModuleDirFromName('MapGenSvgSwitchCountries')+'MapGenSvg.Maps.ini');
  try
    ini.ReadSectionValues('Kraje',aMapCountries);
  finally
    ini.Free();
  end;
  //vyhazeme staty, ktere nemaji SVG mapu a nechame jen jmeno statu
  for i:=aMapCountries.Count-1 downto 0 do begin
    s:=aMapCountries[i];
    if(not RegexFind('(?i)\(.*s.*\)',s)) then begin
      aMapCountries.Delete(i);
      continue;
    end;
    aMapCountries[i]:=Fetch(s,'='); //nechame jen jmeno statu
  end;
  //Log('UUUUU 2 seznam zpracovatelnych statu: '+IntToStr(i)+', '+ReplaceString(Trim(aMapCountries.Text),', ',CRLF));
{$ifdef DEBUG_HELPER} LDH('Seznam zpracovatelnych statu (podle ini souboru): '+ReplaceString(Trim(aMapCountries.Text),', ',CRLF));{$endif}

  //pokud byl pozadovan jen vyber, odstranime staty, ktere tam nepatri
  //!!! zatim neni udelano !!!

  // sestaven seznamu statu, ktere maji v databazi nalez
  Geoget_DB.AddParamText(':Prefix',sCachePrefix+'%');
  sSql:='SELECT Country, count(*) Finds FROM geocache gc'
       +'  WHERE id like :Prefix'
       +'    AND dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
      +' AND gc.id NOT IN ('+sIgnoreCaches+')'
      //+' AND gc.id NOT IN ('+IgnoreAndLocationless()+')'  //tohle zahrnuje i sIgnoreCaches
       +SetSqlFilter(aPar)
       +'  GROUP BY Country'
       +'  ORDER BY '+sOrder;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      sCountry:=UtfToAscii(tab.FieldByName['Country']);
      //zjistime, zda je stat mezi zpracovatelnymi
      if(aMapCountries.IndexOf(sCountry)>=0) then aMaps.Add(sCountry);
      tab.Next();
    end;
  finally
    tab.Free();
  end;
{$ifdef DEBUG_HELPER} LDH('Seznam statu s nalezy, pro ketere je mozne nakreslit mapu: '+ReplaceString(Trim(aMaps.Text),', ',CRLF));{$endif}
  //parsujeme parametry jednotlivych map a modulu, ktere ji kresli
  i:=aMaps.Count;
  //Log('UUUUU aMaps: '+aMapsState.CommaText);
  //vygenerujeme prepinaci tlacitka
  sIdElemOld:=GlobalVarGet('IdElement',false);
  //vygenerujeme div s tlacitky pro kazdou mapu, prvni je zobrazena
  //pripravime pole pro funkci k vytvoreni tlacitek
  aPom:=TStringList.Create();
  try
    for j:=0 to aMaps.Count-1 do begin
      s:=aMaps[j];
      s:='<img src="%IconCountry'+s+'%" />&nbsp;'+s;
      aPom.Add(s); //text na tlacitko
      aPom.Add('i'+MapGenSvgSwitchCountries_MapName(sIdElemOld,j)); //prepinany element
    end;
    Output(OutputSwitchButtons(sIdElemOld,aPar.Values['SwitchType'],5,true,aPom));
  finally
    aPom.Free();
  end;
  sDiv:='';
  aPar.Values['Title']:='';
  aPar.Values['RegionDivide']:='Auto';
  aPar.Values['Data']:='Finds';
  for j:=0 to aMaps.Count-1 do begin
    GlobalVarSet('IdElement',MapGenSvgSwitchCountries_MapName(sIdElemOld,j)); //nove jmeno modulu
    //vytvorime div s identifikaci pro novou mapu
    sDiv:='<div id="i'+MapGenSvgSwitchCountries_MapName(sIdElemOld,j)+'"';
    if(j=0) then sDiv:=sDiv+' style=""'
    else sDiv:=sDiv+' style="display:none;"';
    sDiv:=sDiv+'>'+CRLF;
    Output(sDiv);
    //najdeme a zavolame funkci pro generovani mapy
    aPar.Values['Map']:=aMaps[j]; //jmeno mapy, vlastne stat, ktery budeme kreslit
    fFce:=@MapGenSvg_run;
    Output(fFce(aPar)+'</div>'+CRLF+CRLF);
  end;
  aMapCountries.Free();
  aMaps.Free();
  GlobalVarSet('IdElement',sIdElemOld);
end;